// 'skills' namespace
skills=window.skills || {};

skills.common = (function() {

    // private
    function init() {
        //initialize common code
        initSkillsGraph();
        initSkillsCloud();
    }

    function initSkillsGraph(){
        if (!$('#skills-graph').size()) return;
        // ----- Start Create Canvas For Drawing Our Graph
        var r = Raphael("skills-graph", 450, 450),
            R = 200,
            outerCoord = 450 - R * 2,
            step = 16,
            init = true,
            param = {stroke: "#fff", "stroke-width": 15},
            marksAttr = {fill: "#444", stroke: "none"};
		// ----- End Create Canvas For Drawing Our Graph


        // ----- Start Create Custom Attribute For A Dynamic Arc
        r.customAttributes.arc = function (value, total, R, hexColor) {
            var alpha = 360 / total * value,
                a = (90 - alpha) * Math.PI / 180,
                x = 225 + R * Math.cos(a),
                y = 225 - R * Math.sin(a),
                color = hexColor || "hsb(".concat(Math.round(R) / 200, ",", value / total, ", .75)"),
                path;
            if (total == value) {
                path = [["M", 225, 225 - R], ["A", R, R, 0, 1, 1, 224.99, 225 - R]];
            } else {
                path = [["M", 225, 225 - R], ["A", R, R, 0, +(alpha > 180), 1, x, y]];
            }
            return {path: path, stroke: color};
        };
		// ----- End Create Custom Attribute For A Dynamic Arc
		
		Raphael.el.getAttr = function (nodeName) {
		    var result = this[0].attributes.getNamedItem(nodeName);
		    return result.value;
        };

		/**
		 * animateArc()
		 * Function to animate along the path setup by our top 10 skills.
		 * @param value
		 * @param total
		 * @param R
		 * @param hand -
		 * @param id - html element id that we're using to hold the animation
		 */
		function drawArc(value, total, R, hand, id, hexColor) {
            var color = hexColor || "hsb(".concat(Math.round(R) / 200, ",", value / total, ", .75)");
            if (init) {
                hand.animate({arc: [value, total, R, color]}, 900, ">");
            } else {
                if (!value || value == total) {
                    value = total;
                    hand.animate({arc: [value, total, R, color]}, 750, "bounce", function () {
                        hand.attr({arc: [0, total, R, color]});
                    });
                } else {
                    hand.animate({arc: [value, total, R, color]}, 750, "elastic");
                }
            }
        }
		// ----- drawArc()

		// ----- Start Create Shells Of Arc's For Each Top 10 Skill (used in animation)
		// ----- Start onLoad() function
        (function () {
            var colorArray = ['#EEF2F5','#6B5023','#D6C985','#B3B2B8','#677079','#9B1F39','#AE3B0E','#FB9C1C','#DFD011','#5E6900'];
                // example json = {"rows":[{"key":"php","value":0.6666666666666666},{"key":"cobol","value":0.3333333333333333},{"key":"javascript","value":0.3333333333333333},{"key":"python","value":0.666666666666666},{"key":"ruby","value":0.8888888888888},{"key":"sql","value":0.3333333333333333},{"key":"javascript","value":0.3333333333333333},{"key":"python","value":0.666666666666666},{"key":"ruby","value":0.8888888888888},{"key":"sql","value":0.3333333333333333}]};
        
                if (typeof skill_tags == 'undefined'){
                    var skills = $.ajax({
                      type: 'POST',
                      url: '/taggings/skill_tags_cloud/10',
                      data: 'JSON',
                      success: function(result){
                          processData(result);                      
                      }
                    });
                } else {
                    
                    var result = $.parseJSON(skill_tags);
                    
                    $.each(result.rows,function(i,val){
                        this.value = parseFloat(this.value / 5);
                    });
                    processData(result);

                }
                
                
                function processData(result){
                    $.each(result.rows,function(i,val){
                          var label = this.key,
                              percentageRaw = this.value,
                              percentage = parseInt(100 * percentageRaw),
                              circleLength = 360 * percentageRaw,
                  	          cnt = i + 1,
                  	          arc;

                  	        arc =  r.path().attr(param).attr({arc: [0, 360, R], href: '/taggings/skill_tags/'+escape(label)});
                            // text labels. we start from the outermost circle and work in (subtracting for text size)
                  	        var yAxis = outerCoord - 9;
                  	        var txt = r.text(220,yAxis, label + " (" + percentage + '%)').attr({'text-anchor':'end','fill':'#444','font-weight':'800','font-family':'Arial'});
                  	        var rect = r.rect(220 - txt.getBBox().width - 3, yAxis - 8, txt.getBBox().width + 8, 15).attr({"fill":"#fff","stroke":"transparent","opacity":0.7}).toFront();
                  	        txt.toFront();
                  	        
                  	        // make adjustments
                  	        R -= step;
                  	        outerCoord += step;
                  	        // animate the arc
                  	        drawArc(circleLength, 360, R, arc, cnt);
                  	        
                      });
			        init = false;
                }


        })();
		// ----- End onLoad() function
		/*!
         * The following copyright notice may not be removed under any circumstances.
         * 
         * Copyright:
         * Copyright (c) 2010 Anton Koovit.
         * 
         * Trademark:
         * Arvo is a trademark of Anton Koovit. 2010
         * 
         * Description:
         * Copyright (c) 2010 by Anton Koovit. All rights reserved under SIL openfont
         * License 1.1
         * 
         * Manufacturer:
         * Anton Koovit
         * 
         * Designer:
         * Anton Koovit
         * 
         * Vendor URL:
         * http://www.korkork.com/
         * 
         * License information:
         * http://www.korkork.com/license/arvo/
         */
        Raphael.registerFont({"w":126,"face":{"font-family":"Arvo","font-weight":400,"font-stretch":"normal","units-per-em":"360","panose-1":"2 0 0 0 0 0 0 0 0 0","ascent":"288","descent":"-72","x-height":"5","bbox":"-4 -303 448 89","underline-thickness":"8.78906","underline-position":"-8.78906","unicode-range":"U+0020-U+007E"},"glyphs":{" ":{"d":false,"w":78},"A":{"d":"183,-30r22,0r-21,-61r-103,0r-20,61r27,0r0,30r-86,0r0,-30r23,0r83,-236r52,0r83,236r26,0r0,30r-86,0r0,-30xm91,-120r83,0r-42,-119","w":271,"k":{"y":13,"v":18,"Y":22,"W":18,"V":18,"U":22,"T":32}},"B":{"d":"25,-30r25,0r0,-206r-25,0r0,-31r120,1v11,0,21,2,30,6v9,4,18,9,25,16v7,7,13,16,17,25v4,9,6,19,6,30v0,11,-4,22,-10,31v-6,9,-15,17,-27,23v6,3,11,7,16,11v5,4,9,8,12,13v3,5,6,10,8,15v2,5,2,11,2,17v0,11,-2,21,-6,31v-4,10,-9,18,-16,25v-7,7,-16,13,-25,17v-9,4,-19,6,-30,6r-122,0r0,-30xm85,-118r0,88r62,0v6,0,11,-1,16,-4v5,-3,8,-6,12,-11v4,-5,7,-10,9,-16v2,-6,3,-11,3,-17v0,-5,-1,-10,-3,-15v-2,-5,-5,-9,-9,-13v-4,-4,-7,-7,-12,-9v-5,-2,-10,-3,-16,-3r-62,0xm85,-236r0,87r60,0v6,0,11,-1,16,-3v5,-2,9,-5,13,-9v4,-4,6,-8,8,-13v2,-5,3,-11,3,-16v0,-6,-1,-11,-3,-17v-2,-6,-4,-10,-8,-14v-4,-4,-8,-8,-13,-11v-5,-3,-10,-4,-16,-4r-60,0","w":237},"C":{"d":"214,-196v-8,-13,-18,-24,-31,-32v-13,-8,-27,-11,-43,-11v-14,0,-27,3,-38,9v-11,6,-20,13,-28,23v-8,10,-15,20,-19,33v-4,13,-7,26,-7,40v0,17,3,32,8,45v5,13,11,24,19,32v8,8,17,15,28,21v11,6,23,8,37,8v19,0,34,-4,48,-13v14,-9,25,-23,35,-44r31,14v-4,13,-11,25,-22,37v-11,12,-24,21,-40,28v-16,7,-33,11,-52,11v-18,0,-35,-3,-50,-10v-15,-7,-29,-16,-41,-29v-12,-13,-21,-28,-27,-45v-6,-17,-9,-36,-9,-55v0,-19,3,-36,9,-53v6,-17,15,-32,26,-44v11,-12,25,-23,41,-30v16,-7,33,-11,51,-11v16,0,30,2,42,7v12,5,22,11,30,17v8,6,15,13,21,21r19,0r0,31r-38,0","w":265},"D":{"d":"25,-266r99,0v12,0,24,1,35,4v11,3,22,8,31,14v9,6,18,12,26,20v8,8,14,17,19,27v5,10,10,21,13,32v3,11,4,23,4,35v0,12,-1,25,-4,36v-3,11,-8,22,-13,32v-5,10,-11,19,-19,27v-8,8,-17,15,-26,21v-9,6,-20,10,-31,13v-11,3,-23,5,-35,5r-99,0r0,-30r25,0r0,-206r-25,0r0,-30xm85,-236r0,206r41,0v12,0,24,-3,35,-8v11,-5,20,-13,28,-22v8,-9,15,-20,20,-33v5,-13,7,-26,7,-41v0,-14,-2,-28,-7,-40v-5,-12,-12,-23,-20,-32v-8,-9,-17,-17,-28,-22v-11,-5,-23,-8,-35,-8r-41,0","w":264},"E":{"d":"25,-266r191,0r0,75r-36,0r0,-45r-95,0r0,85r80,0r0,30r-80,0r0,91r95,0r0,-45r36,0r0,75r-191,0r0,-30r25,0r0,-206r-25,0r0,-30","w":226},"F":{"d":"25,-266r191,0r0,75r-36,0r0,-45r-95,0r0,86r91,0r0,29r-91,0r0,91r27,0r0,30r-87,0r0,-30r25,0r0,-206r-25,0r0,-30","w":218,"k":{".":45,",":45,"o":20,"e":20,"c":20,"a":18,"A":13}},"G":{"d":"231,1r0,-53v-4,9,-10,17,-17,24v-7,7,-14,13,-22,17v-8,4,-18,8,-27,10v-9,2,-18,3,-28,3v-17,0,-33,-3,-48,-9v-15,-6,-28,-14,-40,-27v-12,-13,-21,-28,-27,-45v-6,-17,-9,-36,-9,-55v0,-19,3,-36,9,-53v6,-17,15,-32,26,-45v11,-13,25,-22,41,-29v16,-7,33,-11,51,-11v17,0,31,2,43,7v12,5,22,11,31,18v9,7,16,14,21,20r17,0r0,31r-38,0v-8,-13,-18,-24,-31,-32v-13,-8,-27,-11,-43,-11v-13,0,-27,3,-38,9v-11,6,-20,13,-28,23v-8,10,-15,20,-19,33v-4,13,-7,26,-7,40v0,16,3,31,8,44v5,13,10,24,18,32v8,8,18,16,29,21v11,5,23,8,37,8v22,0,41,-5,55,-16v14,-11,24,-29,30,-52r-74,0r0,-30r112,0r0,128r-32,0","w":295},"H":{"d":"212,-266r87,0r0,30r-25,0r0,206r25,0r0,30r-87,0r0,-30r27,0r0,-96r-154,0r0,96r27,0r0,30r-87,0r0,-30r25,0r0,-206r-25,0r0,-30r87,0r0,30r-27,0r0,80r154,0r0,-80r-27,0r0,-30","w":323},"I":{"d":"25,-266r85,0r0,30r-25,0r0,206r25,0r0,30r-85,0r0,-30r25,0r0,-206r-25,0r0,-30","w":135},"J":{"d":"26,-266r87,0r0,30r-23,0r0,206v0,3,0,6,-1,9v-1,3,-3,7,-5,11v-2,4,-4,8,-7,12r-8,12v-6,9,-13,18,-21,28r-30,-3v7,-11,13,-20,19,-30v4,-6,3,-7,6,-13r6,-12v0,0,4,-8,5,-11v1,-3,1,-7,1,-9r0,-200r-29,0r0,-30","w":119},"K":{"d":"202,-236r0,-30r61,0r0,30r-21,0r-117,98r109,108r29,0r0,30r-72,0r0,-30r-106,-106xm25,-266r87,0r0,30r-27,0r0,206r27,0r0,30r-87,0r0,-30r25,0r0,-206r-25,0r0,-30","w":275,"k":{"O":13}},"L":{"d":"25,-266r87,0r0,30r-27,0r0,206r92,0v2,0,3,-1,5,-2r6,-3v0,0,2,-3,3,-5v1,-2,2,-3,2,-5r0,-34r33,0r0,79r-201,0r0,-30r25,0r0,-206r-25,0r0,-30","w":227,"k":{"Y":38,"W":18,"V":18,"T":27}},"M":{"d":"25,-30r25,0r0,-203r-25,0r0,-33r85,0r84,230r86,-230r80,0r0,33r-25,0r0,203r25,0r0,30r-87,0r0,-30r29,0r0,-205r-94,235r-29,0r-95,-235r0,205r28,0r0,30r-87,0r0,-30","w":384},"N":{"d":"190,-266r87,0r0,30r-23,0r0,236r-45,0r-124,-221r0,191r27,0r0,30r-86,0r0,-30r24,0r0,-206r-25,0r0,-31r72,0r121,219r2,-8r0,-180r-30,0r0,-30","w":285},"O":{"d":"140,5v-18,0,-35,-3,-50,-10v-15,-7,-29,-16,-41,-29v-12,-13,-21,-28,-27,-45v-6,-17,-9,-35,-9,-54v0,-19,3,-37,9,-54v6,-17,15,-32,26,-44v11,-12,25,-23,41,-30v16,-7,32,-11,51,-11v19,0,36,4,52,11v16,7,30,18,41,30v11,12,20,27,26,44v6,17,9,35,9,54v0,19,-3,37,-9,54v-6,17,-16,31,-27,44v-11,13,-24,22,-40,29v-16,7,-33,11,-52,11xm140,-27v14,0,27,-3,38,-9v11,-6,21,-13,29,-23v8,-10,15,-21,19,-34v4,-13,6,-26,6,-40v0,-15,-2,-28,-7,-42v-5,-14,-12,-26,-20,-35v-8,-9,-18,-16,-29,-21v-11,-5,-24,-8,-36,-8v-14,0,-27,3,-38,9v-11,6,-21,13,-29,23v-8,10,-14,20,-18,33v-4,13,-6,27,-6,41v0,16,2,31,7,44v5,13,11,24,19,32v8,8,17,15,28,21v11,6,23,9,37,9","w":280,"k":{"Y":9,"X":18}},"P":{"d":"25,-266r108,0v12,0,23,1,33,4v10,3,19,8,26,14v7,6,13,13,17,22v4,9,6,20,6,32v0,10,-2,18,-6,27v-4,9,-10,17,-17,23v-7,6,-16,11,-26,15v-10,4,-22,6,-34,6r-47,0r0,93r27,0r0,30r-87,0r0,-30r25,0r0,-206r-25,0r0,-30xm85,-236r0,84r48,0v7,0,12,-1,18,-3v6,-2,11,-4,15,-8v4,-4,7,-8,9,-13v2,-5,4,-11,4,-18v0,-13,-4,-24,-12,-31v-8,-7,-22,-11,-39,-11r-43,0","w":223,"k":{".":72,",":70,"a":13,"A":22}},"Q":{"d":"123,4v-16,-2,-31,-7,-45,-15v-14,-8,-25,-18,-35,-30v-10,-12,-17,-26,-22,-42v-5,-16,-8,-32,-8,-50v0,-19,3,-37,9,-54v6,-17,15,-32,26,-44v11,-12,25,-23,41,-30v16,-7,32,-11,51,-11v19,0,36,4,52,11v16,7,30,18,41,30v11,12,20,27,26,44v6,17,9,35,9,54v0,18,-3,34,-8,50v-5,16,-13,30,-23,42v-10,12,-21,22,-35,30v-14,8,-29,13,-46,15v8,2,14,4,19,7v5,3,10,7,17,10v7,3,14,5,21,5v7,0,13,-2,18,-5v5,-3,8,-9,10,-16r27,13v-1,7,-4,12,-8,17v-4,5,-9,9,-14,12v-5,3,-10,6,-16,8v-6,2,-11,2,-17,2v-9,0,-18,-2,-26,-5v-8,-3,-16,-7,-25,-12v-9,-5,-17,-7,-25,-7v-5,0,-9,1,-14,3r0,-32xm140,-27v14,0,27,-3,38,-9v11,-6,21,-13,29,-23v8,-10,15,-21,19,-34v4,-13,6,-26,6,-40v0,-15,-2,-29,-7,-42v-5,-13,-11,-26,-20,-35v-9,-9,-18,-16,-29,-21v-11,-5,-23,-8,-36,-8v-14,0,-27,3,-38,9v-11,6,-21,13,-29,23v-8,10,-14,20,-18,33v-4,13,-6,27,-6,41v0,16,2,30,7,43v5,13,11,23,19,32v8,9,17,16,29,22v12,6,23,9,36,9","w":280},"R":{"d":"25,-266r111,0v12,0,23,1,33,4v10,3,19,8,26,14v7,6,13,13,17,22v4,9,6,20,6,32v0,7,-1,12,-3,19v-2,7,-6,12,-10,18v-4,6,-10,11,-16,15v-6,4,-12,8,-19,10v3,1,6,4,9,6v3,2,5,6,8,9v3,3,6,7,8,11v2,4,4,10,5,15r15,58r23,0r0,33r-52,0r-20,-81v-4,-15,-9,-25,-16,-32v-7,-7,-18,-10,-31,-10r-34,0r0,93r27,0r0,30r-87,0r0,-30r25,0r0,-206r-25,0r0,-30xm85,-236r0,84r51,0v7,0,12,-1,18,-3v6,-2,11,-4,15,-8v4,-4,7,-8,9,-13v2,-5,4,-11,4,-18v0,-13,-4,-24,-12,-31v-8,-7,-21,-11,-38,-11r-47,0","w":256},"S":{"d":"156,-217v-4,-5,-7,-9,-12,-12v-5,-3,-10,-5,-15,-6v-5,-1,-11,-3,-16,-3v-9,0,-17,1,-24,3v-7,2,-12,5,-16,9v-4,4,-8,7,-10,12v-2,5,-4,10,-4,15v0,8,2,14,5,19v3,5,6,8,10,11v4,3,9,5,14,7v8,2,8,3,15,5r35,11v11,3,20,8,28,12v8,4,15,9,21,15v6,6,9,13,12,21v3,8,5,17,5,27v0,11,-2,21,-7,30v-5,9,-11,18,-19,25v-8,7,-18,12,-29,16v-11,4,-24,6,-37,6v-14,0,-25,-2,-35,-5v-10,-3,-17,-7,-24,-12v-7,-5,-12,-11,-16,-18v-4,-7,-8,-14,-10,-21r-13,0r0,-30r44,0v0,13,1,23,4,28v3,5,7,9,12,13v5,4,11,6,18,8v7,2,14,3,22,3v8,0,16,-1,22,-3v6,-2,11,-4,16,-8v5,-4,8,-8,10,-13v2,-5,4,-11,4,-17v0,-7,-2,-14,-5,-19v-3,-5,-6,-8,-11,-12v-5,-4,-9,-7,-15,-9v-6,-2,-12,-4,-17,-6r-38,-11v-8,-3,-16,-6,-23,-10v-7,-4,-13,-8,-18,-14v-5,-6,-9,-12,-12,-20v-3,-8,-4,-17,-4,-27v0,-10,2,-20,6,-29v4,-9,10,-16,18,-23v8,-7,17,-12,28,-16v11,-4,25,-5,39,-5v9,0,18,1,26,3v8,2,15,5,22,9v7,4,12,9,17,15v5,6,10,12,13,19r13,0r0,30r-43,0v0,-10,-2,-18,-6,-23","w":212},"T":{"d":"80,-30r24,0r0,-208r-61,0r0,42r-36,0r0,-70r238,0r0,70r-36,0r0,-42r-70,0r0,208r27,0r0,30r-86,0r0,-30","w":252,"k":{".":53,",":53,"u":32,"q":44,"o":43,"n":30,"e":43,"d":43,"c":43,"a":36,"A":32}},"U":{"d":"20,-266r86,0r0,30r-27,0r0,124v0,15,2,28,5,38v3,10,8,19,14,26v6,7,13,11,21,14v8,3,17,5,27,5v10,0,19,-1,27,-4v8,-3,16,-8,22,-14v6,-6,11,-14,14,-25v3,-11,5,-24,5,-40r0,-124r-29,0r0,-30r87,0r0,30r-24,0r0,120v0,19,-3,36,-8,51v-5,15,-13,28,-22,38v-9,10,-20,18,-33,23v-13,5,-26,8,-40,8v-14,0,-27,-3,-39,-8v-12,-5,-23,-13,-32,-23v-9,-10,-17,-22,-22,-36v-5,-14,-8,-31,-8,-50r0,-123r-24,0r0,-30","w":272,"k":{".":13,",":13}},"V":{"d":"178,-266r87,0r0,30r-23,0r-87,236r-48,0r-85,-236r-24,0r0,-30r87,0r0,30r-23,0r68,205r73,-205r-25,0r0,-30","w":261,"k":{".":33,"o":22,"A":18}},"W":{"d":"362,-266r86,0r0,30r-23,0r-76,236r-54,0r-72,-232r-67,232r-53,0r-78,-236r-23,0r0,-30r86,0r0,30r-23,0r65,205r68,-235r52,0r73,235r65,-205r-26,0r0,-30","w":450},"X":{"d":"167,-266r86,0r0,30r-19,0r-72,100r75,106r16,0r0,30r-86,0r0,-30r33,0r-57,-80r-58,80r31,0r0,30r-86,0r0,-30r17,0r76,-106r-71,-100r-22,0r0,-30r86,0r0,30r-25,0r52,73r52,-73r-28,0r0,-30","w":263,"k":{"O":13}},"Y":{"d":"9,-266r86,0r0,30r-25,0r50,86r54,-86r-28,0r0,-30r87,0r0,30r-23,0r-75,113r0,93r27,0r0,30r-86,0r0,-30r24,0r0,-93r-70,-113r-21,0r0,-30","w":238,"k":{".":38,",":35,"s":32,"A":27}},"Z":{"d":"204,-227r-160,197r125,0r0,-45r34,0r0,75r-194,0r0,-40r158,-196r-121,0r0,45r-34,0r0,-75r192,0r0,39","w":213},"_":{"d":"0,27r180,0r0,18r-180,0r0,-18","w":180},"a":{"d":"125,-17v-7,6,-15,12,-23,16v-8,4,-18,6,-29,6v-9,0,-17,-1,-24,-4v-7,-3,-15,-7,-20,-12v-5,-5,-9,-11,-12,-17v-3,-6,-5,-13,-5,-20v0,-8,2,-15,4,-21v2,-6,5,-11,9,-15v4,-4,8,-8,13,-11v5,-3,10,-6,16,-8v6,-2,11,-2,17,-3v6,-1,12,-2,17,-2v8,0,15,0,21,1v6,1,11,1,16,2r0,-15v0,-6,-1,-11,-3,-16v-2,-5,-5,-9,-8,-12v-3,-3,-7,-5,-12,-7v-5,-2,-10,-2,-16,-2v-6,0,-11,0,-16,1v-5,1,-10,2,-14,3v-4,1,-8,2,-12,4v-4,2,-6,3,-9,5r-11,-23v4,-3,9,-5,14,-7v5,-2,10,-5,16,-7v6,-2,12,-3,18,-4v6,-1,11,-1,17,-1v11,0,21,1,29,4v8,3,15,6,21,11v6,5,11,12,14,20v3,8,5,19,5,30r-1,91r21,0r0,30r-53,0r0,-17xm80,-22v4,0,9,-1,13,-2v4,-1,9,-2,13,-4v4,-2,7,-5,10,-7v3,-2,7,-4,9,-7r0,-41r-38,0v-6,0,-12,1,-17,2v-5,1,-10,3,-14,6v-4,3,-7,6,-9,10v-2,4,-3,9,-3,14v0,5,1,8,3,12v2,4,4,7,7,9v3,2,8,5,12,6v4,1,9,2,14,2","w":196},"b":{"d":"10,-274r59,0r0,107v8,-6,16,-10,25,-14v9,-4,19,-6,29,-6v12,0,23,3,33,7v10,4,18,11,25,19v7,8,13,18,17,29v4,11,6,24,6,38v0,15,-3,27,-7,39v-4,12,-10,22,-18,31v-8,9,-17,15,-28,20v-11,5,-23,7,-36,7v-9,0,-18,-1,-26,-4v-8,-3,-14,-6,-20,-10r0,11r-33,0r0,-243r-26,0r0,-31xm114,-158v-9,0,-17,2,-25,6v-8,4,-14,8,-20,14r0,98v4,4,10,7,17,10v7,3,16,5,27,5v8,0,15,-2,22,-5v7,-3,13,-6,18,-12v5,-6,10,-14,13,-22v3,-8,4,-18,4,-29v0,-10,-1,-20,-4,-28v-3,-8,-7,-14,-12,-20v-5,-6,-11,-9,-18,-12v-7,-3,-14,-5,-22,-5","w":220},"c":{"d":"149,-134v-5,-9,-11,-15,-19,-19v-8,-4,-16,-6,-26,-6v-8,0,-14,2,-21,5v-7,3,-13,7,-18,13v-5,6,-9,14,-12,22v-3,8,-4,18,-4,28v0,10,1,19,4,27v3,8,7,15,12,21v5,6,11,11,18,14v7,3,13,4,21,4v11,0,21,-3,29,-8v8,-5,15,-13,20,-24r27,13v-4,8,-8,15,-13,21v-5,6,-10,11,-17,15v-7,4,-14,8,-22,10v-8,2,-15,3,-24,3v-13,0,-24,-2,-35,-7v-11,-5,-20,-11,-28,-20v-8,-9,-14,-19,-18,-31v-4,-12,-7,-24,-7,-38v0,-14,2,-27,7,-39v5,-12,11,-23,19,-31v8,-8,17,-15,28,-20v11,-5,22,-7,34,-7v11,0,23,2,33,6v10,4,19,10,27,18r18,0r0,30r-33,0","w":196},"d":{"d":"125,-274r57,0r0,244r27,0r0,30r-59,0r0,-15v-6,6,-13,11,-21,14v-8,3,-16,5,-26,5v-12,0,-23,-2,-34,-6v-11,-4,-20,-11,-28,-19v-8,-8,-14,-19,-18,-31v-4,-12,-7,-26,-7,-41v0,-14,2,-26,6,-38v4,-12,10,-22,18,-30v8,-8,17,-14,28,-19v11,-5,24,-7,37,-7v9,0,17,1,24,3v7,2,14,6,21,11r0,-70r-25,0r0,-31xm107,-24v10,0,18,-2,25,-5v7,-3,12,-7,18,-13r0,-102v-6,-5,-12,-8,-20,-10v-8,-2,-16,-4,-24,-4v-8,0,-15,2,-22,5v-7,3,-12,6,-17,12v-5,6,-10,12,-13,20v-3,8,-4,18,-4,28v0,11,1,21,4,30v3,9,7,15,12,21v5,6,11,10,18,13v7,3,15,5,23,5","w":222},"e":{"d":"49,-87v0,5,0,10,1,14v1,4,2,9,3,13v4,12,11,20,21,26v10,6,20,9,32,9v9,0,19,-1,28,-4v9,-3,18,-6,28,-12r13,22v-12,8,-24,14,-36,18v-12,4,-24,6,-37,6v-12,0,-25,-2,-35,-6v-10,-4,-19,-10,-27,-18v-8,-8,-13,-19,-17,-31v-4,-12,-7,-26,-7,-42v0,-13,2,-25,6,-37v4,-12,9,-21,16,-30v7,-9,16,-15,27,-20v11,-5,23,-8,37,-8v14,0,25,2,34,6v9,4,17,10,23,17v6,7,10,14,13,23v3,9,5,18,6,27v1,4,1,9,1,14v0,5,1,9,1,13r-131,0xm100,-159v-8,0,-14,1,-20,3v-6,2,-11,5,-15,9v-4,4,-7,9,-9,15v-2,6,-5,13,-6,20r95,0v0,-7,-2,-13,-4,-19v-2,-6,-3,-11,-7,-15v-4,-4,-8,-8,-14,-10v-6,-2,-12,-3,-20,-3","w":206},"f":{"d":"78,-182r42,0r0,26r-42,0r0,126r28,0r0,30r-88,0r0,-30r27,0r0,-126r-30,0r0,-26r30,0r0,-29v0,-11,2,-19,5,-27v3,-8,7,-15,12,-20v5,-5,11,-9,18,-12v7,-3,15,-4,24,-4v6,0,12,0,17,1v5,1,9,2,13,3v4,1,8,2,11,3v3,1,6,3,8,4r-10,23v-4,-2,-9,-4,-15,-5v-6,-1,-12,-2,-19,-2v-10,0,-17,3,-23,9v-6,6,-8,14,-8,26r0,30","w":130},"g":{"d":"151,-16v-6,6,-13,11,-21,15v-8,4,-17,5,-27,5v-12,0,-23,-2,-34,-6v-11,-4,-20,-11,-28,-19v-8,-8,-14,-19,-18,-31v-4,-12,-7,-26,-7,-41v0,-14,2,-26,6,-38v4,-12,10,-22,18,-30v8,-8,17,-14,28,-19v11,-5,24,-7,37,-7v9,0,17,2,24,4v7,2,15,5,22,10r0,-9r33,0r0,175v0,29,-7,50,-21,65v-14,15,-35,22,-64,22v-6,0,-13,0,-20,-1v-7,-1,-13,-3,-20,-5v-7,-2,-14,-4,-20,-7v-6,-3,-12,-7,-17,-12r17,-27v4,3,7,6,12,9v5,3,10,5,15,7v5,2,10,3,16,4v6,1,10,1,16,1v9,0,17,0,24,-2v7,-2,12,-5,16,-10v4,-5,8,-12,10,-20v2,-8,3,-18,3,-30r0,-3xm107,-24v5,0,11,-1,15,-2v4,-1,8,-2,12,-4v4,-2,7,-4,10,-6v3,-2,5,-5,7,-7r0,-100v-6,-5,-13,-9,-21,-11v-8,-2,-16,-4,-24,-4v-8,0,-15,2,-22,5v-7,3,-12,6,-17,12v-5,6,-10,12,-13,20v-3,8,-4,18,-4,28v0,11,1,21,4,30v3,9,7,15,12,21v5,6,11,10,18,13v7,3,15,5,23,5","w":210},"h":{"d":"20,-274r58,0r0,112r1,0v3,-3,7,-6,11,-9v4,-3,9,-6,14,-8v5,-2,9,-4,14,-5v5,-1,10,-1,16,-1v10,0,18,1,26,4v8,3,14,6,20,12v6,6,10,12,13,21v3,9,5,19,5,31r0,87r27,0r0,30r-86,0r0,-30r24,0r0,-83v0,-14,-3,-25,-10,-32v-7,-7,-18,-11,-31,-11v-8,0,-15,1,-23,5v-8,4,-14,9,-21,14r0,107r26,0r0,30r-86,0r0,-30r27,0r0,-213r-25,0r0,-31","w":238},"i":{"d":"16,-182r60,0r0,152r27,0r0,30r-86,0r0,-30r26,0r0,-122r-27,0r0,-30xm36,-247v0,-3,1,-5,2,-8v1,-3,3,-6,5,-8v2,-2,4,-3,7,-4v3,-1,6,-2,9,-2v3,0,6,1,9,2v3,1,5,2,7,4v2,2,4,5,5,8v1,3,2,5,2,8v0,3,-1,6,-2,9v-1,3,-3,6,-5,8v-2,2,-4,4,-7,5v-3,1,-6,2,-9,2v-3,0,-6,-1,-9,-2v-3,-1,-5,-3,-7,-5v-2,-2,-4,-5,-5,-8v-1,-3,-2,-6,-2,-9","w":115},"j":{"d":"15,-182r59,0r0,196v0,10,-1,20,-4,28v-3,8,-7,16,-12,22v-5,6,-12,11,-19,14v-7,3,-16,5,-25,5r-3,-25v10,-2,17,-6,22,-14v5,-8,8,-20,8,-34r0,-162r-26,0r0,-30xm36,-247v0,-3,1,-6,2,-8v1,-2,3,-4,5,-6v2,-2,3,-4,6,-5v3,-1,5,-1,8,-1v3,0,5,0,8,1v3,1,5,3,7,5v2,2,3,4,4,6v1,2,2,5,2,8v0,3,-1,6,-2,9v-1,3,-2,4,-4,6v-2,2,-4,4,-7,5v-3,1,-5,2,-8,2v-3,0,-5,-1,-8,-2v-3,-1,-4,-3,-6,-5v-2,-2,-4,-3,-5,-6v-1,-3,-2,-6,-2,-9","w":106},"k":{"d":"16,-274r64,0r0,31r0,0r0,136r32,0r43,-45r-11,0r0,-30r69,0r0,30r-23,0r-55,57r60,65r22,0r0,30r-38,0r-75,-81r-24,0r0,51r15,0r0,30r-78,0r0,-30r30,0r0,-213r-31,0r0,-31","w":226},"l":{"d":"16,-274r59,0r0,244r28,0r0,30r-87,0r0,-30r27,0r0,-213r-27,0r0,-31","w":117},"m":{"d":"18,-182r58,0r0,21r0,0v4,-3,9,-6,13,-9v4,-3,8,-6,13,-8v5,-2,10,-5,15,-6v5,-1,11,-1,17,-1v13,0,25,2,34,7v9,5,16,13,21,23v4,-4,10,-8,15,-12v5,-4,10,-6,15,-9v5,-3,11,-5,17,-7v6,-2,12,-2,18,-2v10,0,19,1,27,4v8,3,14,6,20,12v6,6,9,12,12,21v3,9,4,19,4,31r0,87r26,0r0,30r-85,0r0,-30r25,0r0,-83v0,-14,-3,-25,-10,-32v-7,-7,-18,-11,-31,-11v-8,0,-16,2,-24,6v-8,4,-15,8,-21,14r0,106r25,0r0,30r-85,0r0,-30r26,0r0,-83v0,-14,-4,-25,-11,-32v-7,-7,-17,-11,-30,-11v-8,0,-15,2,-23,6v-8,4,-15,8,-22,13r0,107r26,0r0,30r-85,0r0,-30r25,0r0,-122r-25,0r0,-30","w":360},"n":{"d":"137,-30r26,0r0,-83v0,-14,-4,-25,-11,-32v-7,-7,-17,-11,-30,-11v-8,0,-15,2,-23,6v-8,4,-15,8,-22,13r0,107r26,0r0,30r-85,0r0,-30r25,0r0,-122r-25,0r0,-30r58,0r0,21r0,0r12,-9v0,0,9,-6,14,-8v5,-2,10,-5,15,-6v5,-1,11,-1,17,-1v10,0,18,1,26,4v8,3,14,6,20,12v6,6,10,12,13,21v3,9,4,19,4,31r0,87r26,0r0,30r-86,0r0,-30","w":240},"o":{"d":"15,-91v0,-14,2,-27,7,-39v5,-12,11,-23,19,-31v8,-8,18,-15,29,-20v11,-5,24,-6,37,-6v13,0,26,1,37,6v11,5,20,12,28,20v8,8,15,18,19,30v4,12,7,26,7,40v0,14,-3,27,-7,39v-4,12,-11,21,-19,30v-8,9,-17,15,-28,20v-11,5,-24,7,-37,7v-14,0,-27,-2,-38,-7v-11,-5,-20,-11,-28,-19v-8,-8,-15,-19,-19,-31v-4,-12,-7,-25,-7,-39xm50,-91v0,10,1,20,4,28v3,8,8,16,13,22v5,6,11,10,18,13v7,3,14,5,22,5v8,0,15,-1,22,-4v7,-3,13,-8,18,-14v5,-6,9,-14,12,-22v3,-8,5,-17,5,-28v0,-11,-2,-20,-5,-29v-3,-9,-7,-16,-12,-22v-5,-6,-11,-10,-18,-13v-7,-3,-14,-4,-22,-4v-8,0,-15,1,-22,4v-7,3,-13,7,-18,13v-5,6,-10,13,-13,22v-3,9,-4,18,-4,29","w":215,"k":{".":9}},"p":{"d":"10,-182r58,0r0,15v8,-6,17,-10,26,-14v9,-4,18,-6,28,-6v12,0,23,3,33,7v10,4,19,11,26,19v7,8,12,18,16,29v4,11,6,24,6,38v0,15,-2,28,-6,40v-4,12,-11,22,-19,31v-8,9,-17,15,-28,20v-11,5,-23,7,-36,7v-9,0,-18,-1,-25,-3v-7,-2,-13,-4,-20,-7r0,59r28,0r0,30r-86,0r0,-30r25,0r0,-205r-26,0r0,-30xm113,-158v-8,0,-16,2,-24,5v-8,3,-14,8,-20,14r0,99v4,4,9,8,16,11v7,3,16,5,27,5v8,0,15,-2,22,-5v7,-3,13,-7,18,-13v5,-6,10,-12,13,-21v3,-9,5,-19,5,-30v0,-10,-2,-20,-5,-28v-3,-8,-7,-14,-12,-20v-5,-6,-11,-9,-18,-12v-7,-3,-14,-5,-22,-5","w":219},"q":{"d":"123,53r26,0r0,-67v-6,6,-12,10,-20,13v-8,3,-16,5,-26,5v-12,0,-23,-2,-34,-6v-11,-4,-20,-11,-28,-19v-8,-8,-14,-19,-18,-31v-4,-12,-7,-26,-7,-41v0,-14,2,-26,6,-38v4,-12,10,-22,18,-30v8,-8,17,-14,28,-19v11,-5,24,-7,37,-7v9,0,16,1,23,3v7,2,14,6,21,10r0,-8r33,0r0,235r27,0r0,30r-86,0r0,-30xm107,-24v10,0,19,-2,26,-5v7,-3,12,-8,16,-12r0,-103v-6,-5,-13,-9,-20,-11v-7,-2,-15,-3,-23,-3v-8,0,-15,2,-22,5v-7,3,-12,6,-17,12v-5,6,-10,13,-13,21v-3,8,-4,17,-4,27v0,11,1,21,4,30v3,9,7,15,12,21v5,6,11,10,18,13v7,3,15,5,23,5","w":211},"r":{"d":"149,-144r-34,0r0,-11v-4,0,-8,1,-12,2v-4,1,-7,4,-11,7v-4,3,-6,6,-9,11v-3,5,-5,11,-6,17r0,88r31,0r0,30r-90,0r0,-30r25,0r0,-122r-25,0r0,-30r58,0r0,25v2,-4,4,-7,7,-10v3,-3,6,-7,9,-9v3,-2,6,-4,10,-5v4,-1,8,-3,13,-3r17,0v5,0,12,1,17,1r0,39","w":168,"k":{".":26,",":30}},"s":{"d":"119,-146v-2,-3,-5,-6,-9,-8v-4,-2,-8,-4,-12,-5v-4,-1,-9,-1,-13,-1v-5,0,-9,0,-13,1v-4,1,-7,3,-10,5v-3,2,-4,4,-6,7v-2,3,-3,6,-3,10v0,6,2,10,6,14v4,4,9,7,18,10r35,12v15,5,26,12,33,21v7,9,11,19,11,31v0,8,-2,15,-5,22v-3,7,-8,12,-14,17v-6,5,-13,8,-21,11v-8,3,-18,4,-28,4v-14,0,-26,-1,-35,-6v-9,-5,-15,-11,-20,-19r-19,0r0,-30r37,0v0,5,1,9,3,13v2,4,5,7,9,9v4,2,7,4,12,5v5,1,9,1,14,1v5,0,9,0,13,-1v4,-1,8,-3,11,-5v3,-2,6,-5,8,-8v2,-3,2,-6,2,-10v0,-6,-1,-11,-5,-15v-4,-4,-11,-8,-20,-11r-35,-13v-14,-5,-24,-12,-31,-20v-7,-8,-10,-17,-10,-29v0,-8,1,-14,4,-21v3,-7,7,-12,12,-17v5,-5,12,-9,20,-12v8,-3,17,-4,27,-4v13,0,24,2,33,6v9,4,17,10,24,19r17,0r0,30r-36,0v0,-5,-2,-10,-4,-13","w":174},"t":{"d":"70,-182r43,0r0,26r-43,0r-1,106v0,7,1,13,3,17v2,4,4,7,8,9v4,2,7,3,12,3v5,0,9,-1,13,-2v4,-1,8,-2,12,-4r8,22v-6,3,-12,5,-18,7v-6,2,-14,2,-22,2v-8,0,-15,-1,-21,-3v-6,-2,-11,-4,-15,-9v-4,-5,-7,-11,-9,-19v-2,-8,-3,-17,-3,-28r1,-101r-29,0r0,-26r29,0r0,-44r32,-15r0,59","w":133},"u":{"d":"127,-182r59,0r0,152r20,0r0,30r-53,0r0,-17v-8,6,-17,11,-27,15v-10,4,-20,5,-31,5v-9,0,-18,-1,-25,-4v-7,-3,-14,-6,-19,-12v-5,-6,-9,-12,-12,-21v-3,-9,-4,-19,-4,-31r0,-87r-24,0r0,-30r58,0r0,113v0,14,4,25,10,32v6,7,16,11,28,11v7,0,14,-1,22,-4v8,-3,16,-6,23,-11r0,-111r-25,0r0,-30","w":237},"v":{"d":"4,-182r62,0r0,30r-17,0r45,126r44,-126r-11,0r0,-30r58,0r0,30r-16,0r-59,155r-33,0r-59,-155r-14,0r0,-30","w":193,"k":{".":33,",":41}},"w":{"d":"4,-182r57,0r0,30r-8,0r32,116r43,-146r28,0r41,146r33,-116r-10,0r0,-30r58,0r0,30r-16,0r-50,155r-30,0r-42,-146r-41,146r-30,0r-50,-155r-15,0r0,-30","w":288,"k":{".":33}},"x":{"d":"122,-30r10,0r-36,-45r-35,45r9,0r0,30r-61,0r0,-30r15,0r55,-65r-52,-57r-18,0r0,-30r60,0r0,30r-6,0r33,43r34,-43r-9,0r0,-30r61,0r0,30r-16,0r-51,60r54,62r13,0r0,30r-60,0r0,-30","w":191},"y":{"d":"5,-182r70,0r0,30r-22,0r43,116r44,-116r-21,0r0,-30r69,0r0,30r-19,0r-81,205r25,0r0,30r-73,0r0,-30r22,0r19,-51r-61,-154r-15,0r0,-30","w":206,"k":{".":38,",":38}},"z":{"d":"13,-20r93,-135r-59,0r0,26r-32,0r0,-53r130,0r0,21r-92,134r62,0r0,-31r34,0r0,58r-136,0r0,-20","w":162},",":{"d":"36,-50r39,15r-46,95r-25,-10","w":100,"k":{" ":41}},"-":{"d":"17,-87r0,-30r96,0r0,30r-96,0","w":129},"\u00ad":{"d":"17,-87r0,-30r96,0r0,30r-96,0","w":129},".":{"d":"17,-21v0,-3,1,-6,2,-9v1,-3,3,-5,5,-7v2,-2,4,-4,7,-5v3,-1,6,-2,9,-2v3,0,6,1,9,2v3,1,5,3,7,5v2,2,4,4,5,7v1,3,2,6,2,9v0,3,-1,6,-2,9v-1,3,-3,5,-5,7v-2,2,-4,4,-7,5v-3,1,-6,2,-9,2v-3,0,-6,-1,-9,-2v-3,-1,-5,-3,-7,-5v-2,-2,-4,-4,-5,-7v-1,-3,-2,-6,-2,-9","w":80},"0":{"d":"115,3v-19,0,-34,-3,-47,-10v-13,-7,-23,-17,-31,-29v-8,-12,-14,-27,-17,-44v-3,-17,-5,-34,-5,-53v0,-20,3,-39,7,-57v4,-18,10,-31,18,-42v8,-11,17,-19,28,-27v11,-8,27,-12,47,-12v19,0,35,3,48,9v13,6,23,16,31,28v8,12,14,28,17,45v3,17,5,35,5,55v0,19,-2,37,-5,54v-3,17,-9,31,-17,43v-8,12,-18,22,-31,29v-13,7,-29,11,-48,11xm115,-28v14,0,25,-2,33,-8v8,-6,15,-13,19,-23v4,-10,8,-21,10,-34v2,-13,3,-26,3,-41v0,-14,0,-27,-2,-40v-2,-13,-5,-24,-10,-34v-5,-10,-12,-18,-20,-24v-8,-6,-20,-8,-33,-8v-14,0,-25,2,-33,8v-8,6,-14,14,-18,22v-4,8,-7,20,-9,34v-2,14,-3,28,-3,42v0,15,1,28,2,41v1,13,4,24,9,34v5,10,11,17,19,23v8,6,19,8,33,8","w":233},"1":{"d":"43,-30r25,0r0,-195r-54,29r0,-37r75,-41r14,0r0,244r26,0r0,30r-86,0r0,-30","w":150},"2":{"d":"15,-26r94,-113v5,-6,5,-5,10,-12v3,-4,7,-9,10,-14v3,-5,5,-10,7,-15v2,-5,3,-10,3,-16v0,-6,-1,-12,-3,-17v-2,-5,-6,-9,-10,-13v-4,-4,-9,-7,-15,-9v-6,-2,-12,-4,-19,-4v-6,0,-12,1,-17,3v-5,2,-10,5,-14,9v-4,4,-7,8,-10,14v-3,6,-4,12,-4,19r-32,0v0,-11,3,-22,7,-31v4,-9,10,-17,17,-24v7,-7,15,-12,24,-16v9,-4,20,-6,30,-6v12,0,22,2,32,6v10,4,18,8,25,15v7,7,12,15,16,24v4,9,6,19,6,30v0,4,0,8,-1,13v-1,5,-4,11,-6,16v-2,5,-5,11,-9,17v-4,6,-9,13,-15,20r-83,99r114,0r0,31r-157,0r0,-26","w":193},"3":{"d":"137,-197v0,-5,-1,-10,-3,-15v-2,-5,-5,-10,-9,-14v-4,-4,-9,-8,-15,-11v-6,-3,-14,-4,-22,-4v-7,0,-13,1,-19,3v-6,2,-11,7,-17,14v-6,7,-9,14,-9,22r-33,0v1,-10,2,-20,7,-28v5,-8,11,-16,18,-22v7,-6,15,-10,24,-14v9,-4,19,-6,29,-6v13,0,24,2,34,6v10,4,19,10,26,17v7,7,13,14,17,23v4,9,6,18,6,27v0,6,-1,11,-2,17v-1,6,-4,11,-7,16v-3,5,-7,10,-12,14v-5,4,-10,9,-17,12v6,2,11,5,16,9v5,4,9,8,13,13v4,5,6,11,8,18v2,7,3,14,3,22v0,11,-2,22,-6,32v-4,10,-10,19,-18,26v-8,7,-17,12,-27,16v-10,4,-21,6,-33,6v-11,0,-21,-1,-32,-5v-11,-4,-20,-10,-27,-17v-7,-7,-12,-13,-16,-21v-4,-8,-6,-15,-7,-23r34,0v3,11,9,20,18,26v9,6,20,9,33,9v6,0,12,-2,18,-4v6,-2,12,-6,16,-10v4,-4,7,-10,10,-16v3,-6,4,-12,4,-19v0,-7,-1,-14,-4,-20v-3,-6,-5,-11,-10,-15v-5,-4,-10,-8,-16,-10v-6,-2,-13,-3,-20,-3r-15,0r0,-27r13,0v8,0,14,-1,20,-3v6,-2,12,-6,16,-10v4,-4,8,-9,10,-14v2,-5,3,-11,3,-17","w":195},"4":{"d":"16,-105r95,-161r37,0r-90,159r68,0r0,-44r35,-3r0,47r40,0r0,30r-40,0r0,47r26,0r0,30r-86,0r0,-30r25,0r0,-47r-110,0r0,-28","w":219},"5":{"d":"56,-157v7,-4,13,-8,20,-10v7,-2,15,-4,24,-4v13,0,25,2,36,7v11,5,20,11,28,19v8,8,15,17,19,28v4,11,6,22,6,34v0,12,-2,23,-6,34v-4,11,-11,20,-19,28v-8,8,-17,14,-28,19v-11,5,-24,7,-38,7v-10,0,-20,-1,-29,-4v-9,-3,-17,-6,-24,-11v-7,-5,-14,-11,-19,-18v-5,-7,-10,-15,-13,-23r29,-14v2,6,4,11,8,16v4,5,8,10,13,14v5,4,10,6,16,8v6,2,12,3,19,3v8,0,17,-1,24,-4v7,-3,14,-8,19,-13v5,-5,9,-12,12,-19v3,-7,5,-15,5,-23v0,-8,-2,-16,-5,-23v-3,-7,-8,-14,-13,-19v-5,-5,-11,-9,-18,-12v-7,-3,-16,-5,-24,-5v-9,0,-18,3,-26,6v-8,3,-14,7,-19,13r-26,-4r0,-139r150,0r0,29r-121,0r0,80","w":200},"6":{"d":"143,-266r-60,99v7,-3,14,-5,20,-5v6,0,10,-1,15,-1v11,0,22,2,32,6v10,4,19,10,27,17v8,7,13,17,18,27v5,10,7,21,7,33v0,15,-2,28,-7,40v-5,12,-12,21,-21,29v-9,8,-18,14,-29,18v-11,4,-23,7,-36,7v-12,0,-24,-3,-35,-7v-11,-4,-20,-10,-29,-18v-9,-8,-16,-17,-21,-28v-5,-11,-7,-24,-7,-37v0,-10,1,-20,5,-30v4,-10,9,-21,15,-32r65,-118r41,0xm105,-144v-8,0,-16,1,-22,4v-6,3,-12,6,-17,11v-5,5,-9,11,-12,18v-3,7,-5,16,-5,26v0,9,2,17,5,24v3,7,8,14,13,19v5,5,12,8,19,11v7,3,15,4,24,4v8,0,15,-1,22,-4v7,-3,14,-7,20,-12v6,-5,10,-12,13,-19v3,-7,5,-14,5,-23v0,-10,-2,-19,-6,-26v-4,-7,-8,-13,-14,-18v-6,-5,-12,-9,-20,-11v-8,-2,-16,-4,-25,-4","w":219},"7":{"d":"32,-30r21,0v6,-18,12,-36,20,-55v11,-28,12,-28,24,-54r23,-51v0,0,12,-24,21,-43r-100,0r0,21r-34,0r0,-54r175,0r0,26r-24,48v0,0,-13,26,-25,53r-24,54v-8,18,-15,37,-21,55r22,0r0,30r-78,0r0,-30","w":189},"8":{"d":"111,-271v10,0,19,1,28,5v9,4,17,9,24,15v7,6,12,14,16,22v4,8,6,17,6,27v0,11,-3,22,-8,32v-5,10,-13,18,-22,24v6,4,12,8,17,13v5,5,8,10,12,16v4,6,7,12,9,19v2,7,2,13,2,20v0,11,-1,22,-6,32v-5,10,-11,18,-19,25v-8,7,-17,13,-27,17v-10,4,-21,7,-33,7v-12,0,-23,-3,-33,-7v-10,-4,-19,-10,-27,-17v-8,-7,-14,-15,-19,-25v-5,-10,-7,-21,-7,-32v0,-7,1,-14,3,-21v2,-7,5,-12,9,-18v4,-6,7,-11,12,-16v5,-5,11,-9,17,-13v-9,-6,-16,-14,-21,-24v-5,-10,-8,-21,-8,-32v0,-10,2,-19,6,-27v4,-8,9,-16,16,-22v7,-6,15,-11,24,-15v9,-4,19,-5,29,-5xm57,-78v0,7,1,13,4,19v3,6,6,11,11,16v5,5,10,8,17,11v7,3,14,4,21,4v7,0,15,-1,21,-4v6,-3,12,-6,17,-11v5,-5,8,-10,11,-16v3,-6,4,-12,4,-19v0,-7,-1,-14,-4,-20v-3,-6,-6,-11,-11,-16v-5,-5,-11,-8,-17,-11v-6,-3,-14,-3,-21,-3v-7,0,-14,0,-21,3v-7,3,-12,6,-17,11v-5,5,-8,10,-11,16v-3,6,-4,13,-4,20xm66,-201v0,6,2,12,4,17v2,5,5,9,9,13v4,4,9,7,14,9v5,2,12,3,18,3v6,0,12,-1,17,-3v5,-2,10,-5,14,-9v4,-4,7,-8,9,-13v2,-5,4,-11,4,-17v0,-6,-2,-11,-4,-16v-2,-5,-5,-10,-9,-14v-4,-4,-9,-7,-14,-9v-5,-2,-11,-3,-17,-3v-6,0,-13,1,-18,3v-5,2,-10,5,-14,9v-4,4,-7,9,-9,14v-2,5,-4,10,-4,16","w":224},"9":{"d":"76,0r61,-101v-6,2,-11,4,-16,5v-5,1,-10,1,-16,1v-10,0,-21,-2,-32,-6v-11,-4,-20,-10,-28,-17v-8,-7,-14,-16,-19,-27v-5,-11,-8,-21,-8,-32v0,-15,3,-28,8,-40v5,-12,11,-21,20,-29v9,-8,19,-15,30,-19v11,-4,23,-6,36,-6v13,0,24,2,35,6v11,4,20,11,29,19v9,8,16,17,21,28v5,11,7,23,7,36v0,10,-2,21,-6,31v-4,10,-9,21,-15,32r-66,119r-41,0xm111,-240v-8,0,-16,1,-23,4v-7,3,-13,7,-19,12v-6,5,-10,11,-13,18v-3,7,-5,15,-5,24v0,10,1,18,5,25v4,7,8,14,14,19v6,5,13,9,20,11v7,2,15,4,22,4v11,0,19,-1,25,-4v6,-3,12,-6,17,-11v5,-5,9,-12,12,-19v3,-7,5,-15,5,-25v0,-9,-2,-18,-5,-25v-3,-7,-7,-13,-12,-18v-5,-5,-12,-8,-19,-11v-7,-3,-15,-4,-24,-4","w":223},"!":{"d":"37,-21v0,-3,1,-6,2,-9v1,-3,3,-5,5,-7v2,-2,4,-4,7,-5v3,-1,6,-2,9,-2v3,0,6,1,9,2v3,1,5,3,7,5v2,2,4,4,5,7v1,3,2,6,2,9v0,3,-1,6,-2,9v-1,3,-3,5,-5,7v-2,2,-4,4,-7,5v-3,1,-6,2,-9,2v-3,0,-6,-1,-9,-2v-3,-1,-5,-3,-7,-5v-2,-2,-4,-4,-5,-7v-1,-3,-2,-6,-2,-9xm37,-277r46,0r-7,205r-32,0","w":119},"%":{"d":"13,-205v0,-8,2,-16,5,-23v3,-7,7,-13,12,-18v5,-5,12,-10,19,-13v7,-3,15,-4,24,-4v9,0,18,1,25,4v7,3,14,8,19,13v5,5,9,11,12,18v3,7,4,15,4,23v0,8,-1,15,-4,22v-3,7,-7,14,-12,19v-5,5,-12,10,-19,13v-7,3,-16,4,-25,4v-9,0,-17,-1,-24,-4v-7,-3,-14,-8,-19,-13v-5,-5,-10,-12,-13,-19v-3,-7,-4,-14,-4,-22xm73,-235v-4,0,-8,2,-12,3v-4,1,-6,3,-9,6v-3,3,-5,5,-7,9v-2,4,-2,8,-2,12v0,4,0,8,2,12v2,4,4,6,7,9v3,3,5,5,9,7v4,2,8,2,12,2v4,0,8,0,12,-2v4,-2,6,-4,9,-7v3,-3,5,-5,7,-9v2,-4,2,-8,2,-12v0,-4,0,-8,-2,-12v-2,-4,-4,-6,-7,-9v-3,-3,-5,-5,-9,-6v-4,-1,-8,-3,-12,-3xm220,-271r34,0r-183,274r-34,0xm165,-57v0,-8,2,-15,5,-22v3,-7,7,-14,12,-19v5,-5,12,-9,19,-12v7,-3,16,-5,25,-5v9,0,17,2,24,5v7,3,14,7,19,12v5,5,9,12,12,19v3,7,5,14,5,22v0,8,-2,16,-5,23v-3,7,-7,13,-12,18v-5,5,-12,10,-19,13v-7,3,-15,5,-24,5v-9,0,-18,-2,-25,-5v-7,-3,-14,-8,-19,-13v-5,-5,-9,-11,-12,-18v-3,-7,-5,-15,-5,-23xm226,-86v-4,0,-8,0,-12,2v-4,2,-7,3,-10,6v-3,3,-4,6,-6,10v-2,4,-3,7,-3,11v0,4,1,8,3,12v2,4,3,7,6,10v3,3,6,4,10,6v4,2,8,2,12,2v4,0,7,0,11,-2v4,-2,7,-3,10,-6v3,-3,4,-6,6,-10v2,-4,2,-8,2,-12v0,-4,0,-7,-2,-11v-2,-4,-3,-7,-6,-10v-3,-3,-6,-4,-10,-6v-4,-2,-7,-2,-11,-2","w":304},"&":{"d":"226,1r-41,-40v-5,6,-10,12,-16,17v-6,5,-11,9,-18,13v-7,4,-14,6,-21,8v-7,2,-15,3,-23,3v-11,0,-22,-2,-32,-6v-10,-4,-19,-9,-26,-16v-7,-7,-14,-15,-18,-24v-4,-9,-6,-20,-6,-31v0,-7,1,-14,3,-21v2,-7,5,-13,9,-19v4,-6,9,-10,14,-15v5,-5,13,-10,24,-16r-12,-11v-3,-3,-6,-6,-9,-10v-3,-4,-6,-7,-8,-11v-2,-4,-4,-9,-5,-14v-1,-5,-2,-9,-2,-13v0,-9,2,-18,6,-26v4,-8,9,-15,15,-21v6,-6,14,-12,22,-15v8,-3,17,-5,27,-5v10,0,19,2,28,6v9,4,17,8,23,14v6,6,11,14,15,22v4,8,5,16,5,25v0,7,-1,13,-2,18v-1,5,-3,11,-6,15v-3,4,-5,8,-9,11v-4,3,-8,7,-12,10v-4,3,-8,6,-12,8v-4,2,-9,5,-13,7r54,50v4,-9,7,-18,9,-26v2,-8,4,-15,5,-22r33,0v-2,11,-5,22,-9,34v-4,12,-10,24,-16,35r49,45xm83,-117v-4,2,-8,4,-11,7v-3,3,-6,6,-8,10v-2,4,-4,7,-5,11v-1,4,-2,9,-2,13v0,7,1,13,4,19v3,6,5,11,10,15v5,4,11,8,17,10v6,2,13,4,20,4v6,0,12,0,17,-2v5,-2,10,-4,15,-7v5,-3,9,-6,13,-10v4,-4,8,-8,11,-12r-67,-65xm138,-180v3,-3,6,-8,8,-12v2,-4,3,-8,3,-13v0,-5,-2,-9,-4,-14v-2,-5,-4,-9,-8,-13v-4,-4,-8,-6,-13,-8v-5,-2,-10,-3,-15,-3v-6,0,-11,1,-16,3v-5,2,-9,5,-12,8v-3,3,-6,7,-8,12v-2,5,-3,10,-3,15v0,5,1,10,3,15v2,5,7,11,13,17r16,15v7,-3,14,-6,20,-10v6,-4,11,-7,16,-12","w":258},"'":{"d":"38,-186r-31,0r0,-91r39,-3","w":59},"\"":{"d":"44,-186r-30,0r-7,-91r40,0xm103,-186r-29,0r-3,-91r41,0","w":114},"(":{"d":"93,79v-11,-13,-20,-27,-28,-41v-8,-14,-16,-30,-22,-45v-6,-15,-10,-31,-13,-47v-3,-16,-5,-33,-5,-50v0,-17,2,-33,5,-49v3,-16,7,-32,13,-47v6,-15,14,-31,22,-45v8,-14,17,-29,28,-42r24,20v-9,12,-17,24,-24,37v-7,13,-13,26,-18,40v-5,14,-9,29,-12,43v-3,14,-4,28,-4,43v0,15,1,30,4,44v3,14,7,29,12,43v5,14,11,27,18,40v7,13,15,25,24,37"},")":{"d":"9,60v9,-12,18,-24,25,-37v7,-13,13,-26,18,-40v5,-14,8,-29,11,-43v3,-14,4,-29,4,-44v0,-15,-1,-29,-4,-43v-3,-14,-6,-29,-11,-43v-5,-14,-11,-27,-18,-40v-7,-13,-16,-25,-25,-37r24,-20v11,13,21,28,29,42v8,14,15,30,21,45v6,15,11,31,14,47v3,16,5,32,5,49v0,17,-2,34,-5,50v-3,16,-8,32,-14,47v-6,15,-13,31,-21,45v-8,14,-18,28,-29,41"},"*":{"d":"85,-228r43,-14r7,21r-44,14r28,38r-19,12r-27,-36r-26,36r-19,-12r28,-38r-46,-14r7,-22r45,14r0,-43r23,0r0,44","w":146},"+":{"d":"25,-139r74,0r0,-74r32,0r0,74r74,0r0,32r-74,0r0,74r-32,0r0,-74r-74,0r0,-32","w":230},"\/":{"d":"112,-276r31,0r-106,281r-30,0","w":149},"@":{"d":"279,-168r0,116v0,7,1,13,3,17v2,4,5,6,8,8v3,2,6,2,10,2v9,0,16,-2,22,-7v6,-5,11,-10,14,-17v3,-7,6,-14,7,-21v1,-7,2,-15,2,-26v0,-12,-2,-24,-5,-35v-3,-11,-9,-22,-15,-32v-6,-10,-13,-19,-22,-27v-9,-8,-18,-15,-29,-21v-11,-6,-22,-11,-34,-14v-12,-3,-26,-5,-39,-5v-13,0,-26,2,-38,5v-12,3,-23,9,-34,15v-11,6,-20,13,-29,22v-9,9,-17,18,-23,29v-6,11,-11,22,-14,34v-3,12,-5,25,-5,38v0,13,2,26,5,38v3,12,8,24,14,35v6,11,14,20,23,29v9,9,18,16,29,22v11,6,22,12,34,15v12,3,25,5,38,5v13,0,26,-2,39,-6v13,-4,24,-8,35,-15r17,28v-13,8,-28,14,-43,18v-15,4,-31,7,-48,7v-16,0,-31,-2,-46,-6v-15,-4,-30,-10,-43,-18v-13,-8,-24,-16,-35,-27v-11,-11,-20,-23,-28,-36v-8,-13,-13,-27,-17,-42v-4,-15,-7,-31,-7,-47v0,-16,3,-31,7,-46v4,-15,9,-29,17,-42v8,-13,17,-25,28,-36v11,-11,22,-19,35,-27v13,-8,28,-14,43,-18v15,-4,30,-6,46,-6v16,0,32,2,47,6v15,4,30,10,43,17v13,7,24,16,35,26v11,10,19,22,27,34v8,12,14,25,18,39v4,14,6,29,6,44v0,8,0,16,-2,24v-2,8,-4,16,-7,23v-3,7,-7,15,-11,21v-4,6,-9,12,-15,17v-6,5,-13,8,-20,11v-7,3,-14,4,-22,4v-11,0,-21,-2,-28,-7v-7,-5,-13,-11,-17,-18v-7,6,-16,11,-25,14v-9,3,-18,5,-29,5v-12,0,-24,-2,-34,-6v-10,-4,-19,-10,-27,-18v-8,-8,-13,-16,-17,-26v-4,-10,-7,-21,-7,-32v0,-11,3,-22,7,-32v4,-10,10,-19,18,-27v8,-8,16,-13,26,-17v10,-4,22,-7,34,-7v9,0,16,2,24,4v8,2,15,6,22,10r0,-15r32,0xm201,-34v11,0,20,-3,28,-8v8,-5,14,-12,18,-20r0,-44v-2,-4,-5,-8,-8,-12v-3,-4,-6,-6,-10,-9v-4,-3,-8,-5,-13,-6v-5,-1,-10,-2,-15,-2v-8,0,-15,1,-21,4v-6,3,-12,6,-17,11v-5,5,-7,10,-10,16v-3,6,-4,13,-4,20v0,7,1,13,3,19v2,6,6,11,11,16v5,5,10,8,16,11v6,3,14,4,22,4","w":406},"[":{"d":"42,-300r71,0r0,27r-39,0r0,313r39,0r0,26r-71,0r0,-366"},"\\":{"d":"7,-278r29,0r123,282r-28,0","w":166},"]":{"d":"53,-273r-39,0r0,-27r71,0r0,366r-71,0r0,-26r39,0r0,-313"},"#":{"d":"30,-211r44,0r11,-55r34,0r-11,55r62,0r11,-55r33,0r-11,55r40,0r-7,35r-39,0r-15,73r42,0r-6,35r-42,0r-14,68r-34,0r14,-68r-62,0r-13,68r-35,0r14,-68r-42,0r7,-35r42,0r14,-73r-44,0xm87,-103r62,0r14,-73r-62,0","w":250},"<":{"d":"2,-134r148,-74r0,32r-119,56r119,55r0,33r-148,-74r0,-28","w":175},"=":{"d":"15,-78r132,0r0,24r-132,0r0,-24xm15,-138r132,0r0,25r-132,0r0,-25","w":162},">":{"d":"177,-106r-148,74r0,-33r119,-55r-119,-56r0,-32r148,74r0,28","w":201},"?":{"d":"59,-21v0,-3,1,-6,2,-9v1,-3,3,-5,5,-7v2,-2,4,-4,7,-5v3,-1,6,-2,9,-2v3,0,6,1,9,2v3,1,5,3,7,5v2,2,4,4,5,7v1,3,2,6,2,9v0,3,-1,6,-2,9v-1,3,-3,5,-5,7v-2,2,-4,4,-7,5v-3,1,-6,2,-9,2v-3,0,-6,-1,-9,-2v-3,-1,-5,-3,-7,-5v-2,-2,-4,-4,-5,-7v-1,-3,-2,-6,-2,-9xm67,-59v0,-12,0,-23,1,-31v1,-8,3,-16,5,-23v2,-7,6,-14,10,-19v4,-5,10,-11,17,-17v6,-5,12,-9,17,-13v5,-4,9,-8,13,-12v4,-4,7,-8,9,-12v2,-4,3,-9,3,-15v0,-5,-1,-11,-3,-16v-2,-5,-5,-9,-9,-13v-4,-4,-7,-7,-12,-9v-5,-2,-10,-3,-16,-3v-9,0,-18,2,-24,5v-6,3,-11,6,-15,11v-4,5,-6,10,-8,15v-2,5,-3,9,-3,13r-31,-2v1,-10,3,-19,7,-28v4,-9,10,-16,17,-23v7,-7,15,-12,25,-16v10,-4,20,-6,32,-6v12,0,22,2,31,6v9,4,17,10,23,16v6,6,11,14,14,22v3,8,5,18,5,27v0,12,-3,23,-9,33v-6,10,-15,19,-27,27v-6,4,-12,9,-19,15v-7,6,-12,14,-15,23v-3,9,-6,17,-6,23r0,22r-32,0","w":187},"$":{"d":"91,33r0,-57v-12,-2,-21,-6,-28,-11v-7,-5,-12,-11,-16,-18r-21,0r0,-30r44,0r0,1r1,0v0,9,3,17,10,22v7,5,16,7,29,7v12,0,21,-1,28,-6v7,-5,10,-12,10,-20v0,-4,-1,-8,-3,-11v-2,-3,-6,-5,-9,-7v-3,-2,-8,-4,-12,-5v-6,-2,-6,-1,-12,-3r-31,-8v-7,-2,-12,-4,-18,-7v-6,-3,-11,-7,-15,-11v-4,-4,-7,-9,-9,-15v-2,-6,-3,-12,-3,-20v0,-7,1,-13,3,-19v2,-6,6,-11,11,-15v5,-4,10,-8,17,-11v7,-3,15,-6,24,-7r0,-60r34,0r0,61v10,2,19,4,26,9v7,5,14,10,18,16r18,0r0,31r-37,0r-4,0r0,0r-1,0r0,-4v-1,-8,-5,-14,-11,-19v-6,-5,-15,-7,-26,-7v-13,0,-22,3,-29,7v-7,4,-10,10,-10,17v0,5,1,8,3,11v2,3,6,6,9,8v3,2,6,3,10,4r12,3r30,9v8,2,15,5,21,8v6,3,12,7,16,11v4,4,7,9,9,14v2,5,4,11,4,18v0,7,-1,15,-4,21v-3,6,-7,11,-12,16v-5,5,-11,10,-18,13v-7,3,-15,6,-24,7r0,57r-34,0","w":212},"{":{"d":"23,-127v5,0,9,-1,13,-4v4,-3,8,-7,10,-11v2,-4,4,-9,5,-15v1,-6,2,-11,2,-17r0,-79v0,-7,1,-14,3,-20v2,-6,6,-11,9,-15v3,-4,7,-7,11,-9v4,-2,9,-3,14,-3r24,0r0,22r-12,0v-6,0,-11,3,-13,9v-2,6,-4,15,-4,26r0,75v0,7,0,14,-2,20v-2,6,-3,11,-6,15v-3,4,-6,7,-10,10v-4,3,-7,5,-11,7r0,0v4,2,7,4,11,7v4,3,7,6,10,10v3,4,4,9,6,15v2,6,2,12,2,19r0,74v0,11,2,20,4,26v2,6,7,9,13,9r12,0r0,22r-24,0v-5,0,-10,-1,-14,-3v-4,-2,-8,-5,-11,-9v-3,-4,-7,-8,-9,-14v-2,-6,-3,-13,-3,-20r0,-78v0,-6,-1,-11,-2,-17v-1,-6,-3,-11,-5,-15v-2,-4,-6,-8,-10,-11v-4,-3,-8,-4,-13,-4r0,-22"},"|":{"d":"27,-303r27,0r0,350r-27,0r0,-350","w":79},"}":{"d":"13,66r0,-22r12,0v6,0,11,-3,13,-9v2,-6,3,-15,3,-26r0,-74v0,-7,1,-13,3,-19v2,-6,3,-11,6,-15v3,-4,5,-7,9,-10v4,-3,8,-5,12,-7r0,0v-4,-2,-8,-4,-12,-7v-4,-3,-6,-6,-9,-10v-3,-4,-4,-9,-6,-15v-2,-6,-3,-13,-3,-20r0,-75v0,-11,-1,-20,-3,-26v-2,-6,-7,-9,-13,-9r-12,0r0,-22r24,0v5,0,9,1,13,3v4,2,9,5,12,9v3,4,7,9,9,15v2,6,3,13,3,20r0,79v0,6,1,11,2,17v1,6,3,11,5,15v2,4,5,8,9,11v4,3,8,4,13,4r0,22v-5,0,-9,1,-13,4v-4,3,-7,7,-9,11v-2,4,-4,9,-5,15v-1,6,-2,11,-2,17r0,78v0,7,-1,14,-3,20v-2,6,-6,10,-9,14v-3,4,-8,7,-12,9v-4,2,-8,3,-13,3r-24,0"},"~":{"d":"25,-85v5,-10,11,-18,18,-23v7,-5,17,-8,27,-8v7,0,14,1,21,4r21,9v10,5,10,4,19,8v6,3,12,4,16,4v5,0,10,-2,15,-6v5,-4,10,-10,16,-20r13,20v-5,10,-11,18,-18,23v-7,5,-16,8,-27,8v-5,0,-9,-1,-14,-2v-5,-1,-9,-3,-14,-5v-5,-2,-9,-4,-14,-6v-7,-3,-7,-3,-13,-6v-4,-2,-8,-4,-12,-5v-4,-1,-7,-1,-10,-1v-5,0,-10,2,-15,6v-5,4,-10,10,-16,20","w":216},":":{"d":"17,-159v0,-3,1,-6,2,-9v1,-3,3,-5,5,-7v2,-2,4,-4,7,-5v3,-1,6,-2,9,-2v3,0,6,1,9,2v3,1,5,3,7,5v2,2,4,4,5,7v1,3,2,6,2,9v0,3,-1,6,-2,9v-1,3,-3,5,-5,7v-2,2,-4,4,-7,5v-3,1,-6,2,-9,2v-3,0,-6,-1,-9,-2v-3,-1,-5,-3,-7,-5v-2,-2,-4,-4,-5,-7v-1,-3,-2,-6,-2,-9xm17,-21v0,-3,1,-6,2,-9v1,-3,3,-5,5,-7v2,-2,4,-4,7,-5v3,-1,6,-2,9,-2v3,0,6,1,9,2v3,1,5,3,7,5v2,2,4,4,5,7v1,3,2,6,2,9v0,3,-1,6,-2,9v-1,3,-3,5,-5,7v-2,2,-4,4,-7,5v-3,1,-6,2,-9,2v-3,0,-6,-1,-9,-2v-3,-1,-5,-3,-7,-5v-2,-2,-4,-4,-5,-7v-1,-3,-2,-6,-2,-9","w":92},";":{"d":"17,-159v0,-3,1,-6,2,-9v1,-3,3,-5,5,-7v2,-2,4,-4,7,-5v3,-1,6,-2,9,-2v3,0,6,1,9,2v3,1,5,3,7,5v2,2,4,4,5,7v1,3,2,6,2,9v0,3,-1,6,-2,9v-1,3,-3,5,-5,7v-2,2,-4,4,-7,5v-3,1,-6,2,-9,2v-3,0,-6,-1,-9,-2v-3,-1,-5,-3,-7,-5v-2,-2,-4,-4,-5,-7v-1,-3,-2,-6,-2,-9xm29,-50r38,15r-45,95r-26,-10","w":92},"`":{"d":"68,-207r-50,-50r0,-3r43,0r33,53r-26,0","w":103},"^":{"d":"118,-266r71,139r-25,0r-56,-110r-56,110r-25,0r71,-139r20,0","w":216},"\u00a0":{"d":false,"w":78}}});
        /*!
         * The following copyright notice may not be removed under any circumstances.
         * 
         * Copyright:
         * Copyright (c) 2010 by Anton Koovit.
         * 
         * Trademark:
         * Arvo is a trademark of Anton Koovit. 2010
         * 
         * Description:
         * Copyright (c) 2010 by Anton Koovit. All rights reserved under SIL openfont
         * License 1.1
         * 
         * Manufacturer:
         * Anton Koovit
         * 
         * Designer:
         * Anton Koovit
         * 
         * Vendor URL:
         * http://www.korkork.com/
         * 
         * License information:
         * http://www.korkork.com/license/arvo/
         */
        Raphael.registerFont({"w":218,"face":{"font-family":"Arvo","font-weight":700,"font-stretch":"normal","units-per-em":"360","panose-1":"2 0 0 0 0 0 0 0 0 0","ascent":"288","descent":"-72","x-height":"4","bbox":"-11 -311 411 90","underline-thickness":"17.9297","underline-position":"-18.1055","unicode-range":"U+0020-U+007E"},"glyphs":{" ":{"w":72},"A":{"d":"157,-48r27,0r-12,-38r-82,0r-12,38r28,0r0,48r-101,0r0,-48r20,0r72,-218r71,0r71,218r19,0r0,48r-101,0r0,-48xm104,-131r53,0r-27,-87","w":262,"k":{"Y":26,"V":18,"T":18}},"B":{"d":"20,-48r27,0r0,-170r-27,0r0,-49r130,1v12,0,23,2,33,6v10,4,19,10,26,17v7,7,13,16,17,26v4,10,6,20,6,31v0,13,-2,24,-7,32v-5,8,-11,16,-19,21v9,6,16,12,21,20v5,8,7,19,7,31v0,12,-2,23,-6,33v-4,10,-10,19,-17,26v-7,7,-16,13,-26,17v-10,4,-20,6,-31,6r-134,0r0,-48xm105,-110r0,62r45,0v3,0,6,-1,9,-3v3,-2,6,-4,8,-7v2,-3,4,-6,5,-10v1,-4,2,-8,2,-12v0,-4,-1,-8,-2,-12v-1,-4,-3,-6,-5,-9v-2,-3,-5,-5,-8,-7v-3,-2,-6,-2,-9,-2r-45,0xm105,-218r0,60r42,0v3,0,7,-1,10,-3v3,-2,5,-3,7,-6v2,-3,4,-7,5,-10v1,-3,2,-7,2,-11v0,-4,-1,-6,-2,-10v-1,-4,-3,-7,-5,-10v-2,-3,-4,-5,-7,-7v-3,-2,-7,-3,-10,-3r-42,0","w":243},"C":{"d":"194,-185v-7,-9,-12,-16,-17,-20v-5,-4,-11,-7,-17,-9v-6,-2,-13,-2,-20,-2v-10,0,-19,2,-27,6v-8,4,-16,10,-22,18v-6,8,-10,17,-14,27v-4,10,-6,20,-6,31v0,11,3,22,6,32v3,10,8,19,14,27v6,8,14,14,22,18v8,4,17,6,27,6v7,0,14,-1,20,-3v6,-2,12,-5,17,-9v5,-4,9,-8,13,-13v4,-5,7,-10,9,-15r56,15v-4,11,-9,22,-16,32v-7,10,-15,19,-25,26v-10,7,-22,13,-34,17v-12,4,-26,6,-40,6v-12,0,-23,-2,-34,-5v-11,-3,-21,-8,-31,-14v-10,-6,-18,-14,-26,-22v-8,-8,-14,-18,-20,-28v-6,-10,-10,-21,-13,-33v-3,-12,-4,-24,-4,-37v0,-19,3,-36,10,-53v7,-17,15,-32,27,-44v12,-12,25,-23,41,-30v16,-7,32,-10,50,-10v14,0,27,1,37,5v10,4,20,10,32,21r40,0r0,60r-55,0","w":273},"D":{"d":"14,-266r103,0v12,0,24,1,35,4v11,3,21,8,31,14v10,6,18,12,26,20v8,8,15,17,21,27v6,10,10,21,13,32v3,11,4,23,4,35v0,12,-1,25,-4,36v-3,11,-7,22,-13,32v-6,10,-13,19,-21,27v-8,8,-16,15,-26,21v-10,6,-20,10,-31,13v-11,3,-23,5,-35,5r-103,0r0,-48r22,0r0,-170r-22,0r0,-48xm94,-218r0,170r22,0v9,0,19,-3,27,-7v8,-4,16,-10,22,-18v6,-8,11,-17,15,-27v4,-10,5,-22,5,-34v0,-12,-1,-23,-5,-33v-4,-10,-9,-19,-15,-27v-6,-8,-14,-14,-22,-18v-8,-4,-18,-6,-27,-6r-22,0","w":258},"E":{"d":"20,-266r212,0r0,90r-57,0r0,-37r-69,0r0,52r53,0r0,51r-53,0r0,62r69,0r0,-47r57,0r0,95r-212,0r0,-48r28,0r0,-165r-28,0r0,-53","w":242},"F":{"d":"20,-266r206,0r0,90r-57,0r0,-37r-63,0r0,56r54,0r0,51r-54,0r0,58r28,0r0,48r-114,0r0,-48r27,0r0,-165r-27,0r0,-53","w":226,"k":{".":44,",":39}},"G":{"d":"213,0r0,-46v-7,13,-14,22,-21,28v-7,6,-15,11,-24,15v-9,4,-20,5,-35,5v-7,0,-15,0,-22,-2v-7,-2,-14,-4,-21,-7v-7,-3,-13,-6,-20,-10v-7,-4,-12,-9,-17,-14v-13,-13,-24,-29,-31,-46v-7,-17,-10,-37,-10,-57v0,-13,1,-24,4,-36v3,-12,7,-23,13,-33v6,-10,12,-20,20,-28v8,-8,16,-15,26,-21v10,-6,20,-11,31,-14v11,-3,22,-5,34,-5v14,0,26,1,36,5v10,4,21,11,33,21r40,0r0,60r-55,0v-5,-8,-10,-15,-15,-19v-5,-4,-9,-7,-15,-9v-6,-2,-14,-4,-24,-4v-10,0,-19,3,-27,7v-8,4,-16,10,-22,18v-6,8,-10,17,-14,27v-4,10,-6,20,-6,31v0,11,2,21,5,31v3,10,9,18,15,26v6,8,13,13,22,17v9,4,17,7,27,7v12,0,24,-4,33,-11v9,-7,16,-17,20,-30r-51,0r0,-48r124,0r0,142r-53,0","w":287},"H":{"d":"198,-266r115,0r0,48r-29,0r0,170r29,0r0,48r-115,0r0,-48r28,0r0,-68r-120,0r0,68r28,0r0,48r-114,0r0,-48r27,0r0,-170r-27,0r0,-48r114,0r0,48r-28,0r0,55r120,0r0,-55r-28,0r0,-48","w":332},"I":{"d":"20,-266r114,0r0,48r-28,0r0,170r28,0r0,48r-114,0r0,-48r27,0r0,-170r-27,0r0,-48","w":142},"J":{"d":"14,-266r101,0r0,53r-18,0r0,183v-3,9,-7,18,-12,26v-5,8,-9,15,-14,21v-5,6,-11,15,-20,25r-49,-3v7,-11,12,-19,16,-26v4,-7,8,-15,12,-23v4,-8,7,-17,9,-26r0,-177r-25,0r0,-53","w":120},"K":{"d":"20,-266r114,0r0,48r-28,0r0,77r85,-74r0,-51r91,0r0,51r-20,0r-89,77r85,86r22,0r0,52r-88,0r0,-52r-86,-86r0,90r28,0r0,48r-114,0r0,-48r27,0r0,-170r-27,0r0,-48","w":290},"L":{"d":"20,-266r114,0r0,48r-28,0r0,170r58,0v2,0,3,0,4,-1r4,-4v0,0,2,-2,3,-4v1,-2,1,-3,1,-5r0,-36r57,0r0,98r-213,0r0,-48r27,0r0,-170r-27,0r0,-48","w":236},"M":{"d":"20,-48r25,0r0,-170r-25,0r0,-48r110,0r78,192r73,-192r111,0r0,48r-24,0r0,170r24,0r0,48r-100,0r0,-48r19,0r0,-153r-80,198r-50,0r-81,-193r0,148r20,0r0,48r-100,0r0,-48","w":412},"N":{"d":"188,-266r102,0r0,48r-22,0r0,218r-58,0r-111,-172r0,124r22,0r0,48r-101,0r0,-48r22,0r0,-170r-22,0r0,-48r81,0r110,174r0,-126r-23,0r0,-48","w":298},"O":{"d":"140,5v-12,0,-23,-2,-34,-5v-11,-3,-21,-8,-31,-14v-10,-6,-18,-14,-26,-22v-8,-8,-14,-18,-20,-28v-6,-10,-10,-21,-13,-33v-3,-12,-4,-23,-4,-36v0,-13,1,-25,4,-37v3,-12,7,-23,13,-33v6,-10,12,-20,20,-28v8,-8,16,-16,26,-22v10,-6,20,-10,31,-13v11,-3,22,-5,34,-5v12,0,24,2,35,5v11,3,21,7,31,13v10,6,18,14,26,22v8,8,14,18,20,28v6,10,10,21,13,33v3,12,5,24,5,37v0,13,-2,24,-5,36v-3,12,-7,23,-13,33v-6,10,-12,20,-20,28v-8,8,-16,16,-26,22v-10,6,-20,11,-31,14v-11,3,-23,5,-35,5xm140,-50v10,0,20,-3,28,-7v8,-4,16,-10,22,-18v6,-8,12,-16,15,-26v3,-10,5,-21,5,-32v0,-11,-3,-22,-6,-32v-3,-10,-8,-19,-14,-27v-6,-8,-14,-14,-22,-18v-8,-4,-18,-6,-28,-6v-10,0,-19,2,-27,6v-8,4,-16,10,-22,18v-6,8,-11,17,-14,27v-3,10,-6,21,-6,32v0,11,3,22,6,32v3,10,8,18,14,26v6,8,14,14,22,18v8,4,17,7,27,7","w":284},"P":{"d":"20,-266r123,0v14,0,27,2,38,6v11,4,21,10,29,17v8,7,15,16,20,25v5,9,7,20,7,30v0,12,-2,24,-6,35v-4,11,-9,20,-17,28v-8,8,-17,14,-29,19v-12,5,-26,7,-42,7r-37,0r0,51r24,0r0,48r-110,0r0,-48r27,0r0,-170r-27,0r0,-48xm106,-218r0,71r24,0v13,0,24,-2,32,-8v8,-6,11,-15,11,-27v0,-11,-4,-20,-11,-26v-7,-6,-18,-10,-32,-10r-24,0","w":246,"k":{".":53,",":53}},"Q":{"d":"116,2v-15,-3,-29,-9,-42,-17v-13,-8,-24,-18,-33,-30v-9,-12,-17,-25,-22,-40v-5,-15,-7,-31,-7,-48v0,-13,1,-25,4,-37v3,-12,7,-23,13,-33v6,-10,12,-20,20,-28v8,-8,16,-16,26,-22v10,-6,20,-10,31,-13v11,-3,22,-5,34,-5v12,0,24,2,35,5v11,3,21,7,31,13v10,6,18,14,26,22v8,8,14,18,20,28v6,10,10,21,13,33v3,12,5,24,5,37v0,17,-3,33,-8,48v-5,15,-13,29,-23,41v-10,12,-21,22,-34,30v-13,8,-28,14,-43,17v4,2,7,3,11,5v4,2,7,3,11,5v4,2,7,3,11,4v4,1,7,2,11,2v4,0,7,-1,10,-2v3,-1,7,-2,10,-4v3,-2,5,-5,7,-8v2,-3,3,-7,4,-12r40,20v-1,9,-4,16,-8,23v-4,7,-8,13,-14,18v-6,5,-13,8,-21,11v-8,3,-15,4,-24,4v-7,0,-14,-1,-21,-4v-7,-3,-13,-5,-20,-8v-10,-5,-10,-5,-19,-9v-6,-3,-11,-4,-15,-4r-5,0r-4,0v0,0,-3,1,-5,1v-2,0,-4,0,-6,1xm140,-50v10,0,20,-3,28,-7v8,-4,16,-10,22,-18v6,-8,12,-16,15,-26v3,-10,5,-21,5,-32v0,-11,-3,-22,-6,-32v-3,-10,-8,-19,-14,-27v-6,-8,-14,-14,-22,-18v-8,-4,-18,-6,-28,-6v-10,0,-19,2,-27,6v-8,4,-16,10,-22,18v-6,8,-11,17,-14,27v-3,10,-6,21,-6,32v0,11,3,22,6,32v3,10,8,18,14,26v6,8,14,14,22,18v8,4,17,7,27,7","w":287},"R":{"d":"20,-266r141,0v14,0,26,2,37,6v11,4,20,9,27,16v7,7,13,15,17,24v4,9,6,18,6,28v0,9,-1,17,-3,24v-2,7,-5,13,-9,18v-4,5,-8,10,-13,14v-5,4,-12,8,-19,11v6,3,11,8,16,14v5,6,8,15,10,25r9,34r22,0r1,52r-78,0r-10,-63v-1,-8,-3,-15,-5,-20v-2,-5,-5,-10,-9,-13v-4,-3,-8,-6,-13,-8v-5,-2,-12,-2,-19,-2r-22,0r0,58r24,0r0,48r-110,0r0,-48r27,0r0,-170r-27,0r0,-48xm106,-218r0,64r35,0v7,0,13,0,18,-1v5,-1,10,-3,14,-6v4,-3,6,-6,8,-10v2,-4,3,-8,3,-14v0,-10,-4,-19,-11,-25v-7,-6,-18,-8,-32,-8r-35,0","w":268},"S":{"d":"148,-191v-1,-4,-2,-8,-4,-12v-2,-4,-5,-6,-9,-9v-4,-3,-7,-5,-12,-7v-5,-2,-9,-2,-14,-2v-4,0,-9,0,-13,1v-4,1,-7,3,-10,5v-3,2,-5,4,-7,7v-2,3,-2,7,-2,11v0,5,1,10,3,13v2,3,5,5,9,7v4,2,8,4,12,5v4,1,8,3,12,4r49,16v7,2,13,6,19,10v6,4,11,9,15,15v4,6,8,12,10,20v2,8,4,17,4,26v0,13,-3,24,-8,35v-5,11,-11,19,-20,27v-9,8,-18,14,-30,18v-12,4,-25,6,-40,6v-10,0,-20,-1,-29,-3v-9,-2,-17,-6,-25,-10v-8,-4,-14,-9,-20,-15v-6,-6,-10,-13,-13,-21r-18,0r0,-53r64,0r0,11v0,5,0,11,2,15v2,4,5,8,8,11v3,3,8,6,13,8v5,2,11,3,18,3v11,0,18,-3,24,-8v6,-5,8,-11,8,-20v0,-4,-1,-8,-3,-11v-2,-3,-4,-6,-7,-8v-3,-2,-6,-4,-10,-5v-4,-1,-7,-3,-11,-4r-41,-13v-8,-2,-15,-6,-22,-10v-7,-4,-13,-9,-18,-15v-5,-6,-10,-15,-13,-23v-3,-8,-5,-18,-5,-29v0,-13,2,-24,7,-34v5,-10,11,-18,19,-25v8,-7,18,-11,30,-15v12,-4,25,-5,39,-5v11,0,21,0,30,3v9,3,18,6,25,10v7,4,13,10,18,15v5,5,9,11,12,17r18,0r0,53r-64,0r0,-15"},"T":{"d":"66,-48r27,0r0,-172r-32,0r0,35r-57,0r0,-81r242,0r0,81r-58,0r0,-35r-36,0r0,172r28,0r0,48r-114,0r0,-48","w":251,"k":{".":49,",":49,"q":35,"o":35,"g":35,"e":35,"d":35,"c":35,"a":26,"A":18}},"U":{"d":"9,-266r107,0r0,48r-25,0r0,110v0,10,2,19,4,26v2,7,5,13,9,17v4,4,9,8,15,10v6,2,11,3,18,3v7,0,13,0,19,-2v6,-2,11,-6,15,-10v4,-4,7,-10,9,-17v2,-7,4,-16,4,-27r0,-110r-29,0r0,-48r107,0r0,48r-21,0r0,104v0,19,-3,35,-8,50v-5,15,-14,27,-23,37v-9,10,-20,18,-33,23v-13,5,-26,8,-41,8v-14,0,-27,-3,-40,-8v-13,-5,-24,-13,-33,-23v-9,-10,-17,-22,-22,-36v-5,-14,-8,-30,-8,-48r0,-107r-24,0r0,-48","w":274},"V":{"d":"151,-266r114,0r0,48r-23,0r-72,218r-72,0r-69,-218r-25,0r0,-48r114,0r0,48r-29,0r47,151r46,-151r-31,0r0,-48","w":268,"k":{".":32,",":32,"u":18,"q":28,"o":28,"m":18,"g":28,"e":28,"d":28,"c":28,"a":18,"A":18}},"W":{"d":"297,-266r114,0r0,48r-24,0r-62,218r-76,0r-40,-166r-41,166r-75,0r-63,-218r-26,0r0,-48r114,0r0,48r-28,0r39,143r47,-191r66,0r46,191r40,-143r-31,0r0,-48","w":414},"X":{"d":"151,-266r113,0r0,48r-9,0r-81,85r81,85r8,0r0,48r-113,0r0,-48r27,0r-41,-44r-41,44r24,0r0,48r-113,0r0,-48r12,0r79,-85r-81,-85r-9,0r0,-48r113,0r0,48r-27,0r43,45r42,-45r-27,0r0,-48","w":277},"Y":{"d":"8,-266r114,0r0,48r-22,0r36,61r37,-61r-25,0r0,-48r114,0r0,48r-20,0r-79,107r0,63r32,0r0,48r-118,0r0,-48r29,0r0,-63r-74,-107r-24,0r0,-48","w":270,"k":{".":40,",":35,"q":35,"o":35,"e":35,"d":35,"c":35,"a":26,"A":18}},"Z":{"d":"213,-211r-132,159r75,0r0,-42r57,0r0,94r-202,0r0,-55r129,-159r-72,0r0,42r-57,0r0,-94r202,0r0,55","w":226},"_":{"d":"0,16r180,0r0,45r-180,0r0,-45","w":180},"a":{"d":"126,-10v-4,3,-8,5,-11,7v-3,2,-7,3,-10,4v-3,1,-7,2,-11,3v-4,1,-8,0,-12,0v-11,0,-20,-1,-29,-4v-9,-3,-16,-7,-22,-12v-6,-5,-11,-12,-14,-19v-3,-7,-4,-15,-4,-23v0,-8,1,-16,4,-23v3,-7,8,-14,14,-19v6,-5,14,-9,23,-12v9,-3,19,-4,30,-4v8,0,16,0,23,1v7,1,13,3,19,4r0,-6v0,-5,-1,-9,-3,-12v-2,-3,-4,-6,-7,-8v-3,-2,-7,-4,-11,-5v-4,-1,-10,-1,-15,-1v-11,0,-21,1,-29,3v-8,2,-16,5,-24,9r-17,-34v12,-8,24,-15,37,-19v13,-4,27,-6,42,-6v11,0,22,1,32,4v10,3,17,6,24,12v7,6,13,13,17,22v4,9,6,21,6,34r0,66r24,0r0,48r-76,0r0,-10xm86,-37v8,0,16,-1,23,-4v7,-3,12,-6,17,-10r0,-23r-42,0v-3,0,-5,0,-8,1v-3,1,-5,2,-7,4v-2,2,-4,3,-5,5v-1,2,-2,5,-2,8v0,5,2,9,6,13v4,4,10,6,18,6","w":225},"b":{"d":"5,-274r80,0r0,96v6,-3,12,-5,19,-7v7,-2,14,-3,21,-3v13,0,26,3,37,8v11,5,22,12,30,21v8,9,14,18,19,30v5,12,7,24,7,37v0,13,-1,25,-6,37v-5,12,-12,21,-20,30v-8,9,-19,16,-30,21v-11,5,-23,7,-37,7v-7,0,-14,-1,-21,-2v-7,-1,-13,-3,-19,-6r0,5r-54,0r0,-225r-26,0r0,-49xm121,-139v-8,0,-15,1,-21,5v-6,4,-11,8,-15,15r0,55v4,6,9,10,15,13v6,3,13,6,21,6v6,0,12,-2,17,-4v5,-2,10,-5,14,-9v4,-4,7,-9,9,-15v2,-6,4,-12,4,-19v0,-7,-2,-13,-4,-19v-2,-6,-5,-11,-9,-15v-4,-4,-9,-8,-14,-10v-5,-2,-11,-3,-17,-3","w":229},"c":{"d":"150,-119v-5,-6,-10,-12,-16,-15v-6,-3,-14,-4,-22,-4v-7,0,-13,1,-19,3v-6,2,-10,6,-14,10v-4,4,-8,9,-10,15v-2,6,-3,13,-3,20v0,6,1,12,3,18v2,6,6,11,10,15v4,4,8,8,14,10v6,2,12,4,19,4v6,0,10,-2,15,-4v5,-2,8,-4,12,-7v4,-3,6,-5,9,-9v3,-4,5,-7,6,-10r48,13v-2,7,-5,14,-10,22v-5,8,-11,15,-19,21v-8,6,-17,11,-28,15v-11,4,-23,6,-37,6v-14,0,-26,-2,-38,-7v-12,-5,-22,-12,-30,-21v-8,-9,-15,-19,-20,-31v-5,-12,-7,-24,-7,-38v0,-13,2,-26,7,-38v5,-12,11,-21,20,-30v9,-9,19,-15,31,-20v12,-5,24,-7,38,-7v10,0,20,1,29,4v9,3,18,7,26,12r35,0r0,53r-49,0","w":207},"d":{"d":"122,-274r79,0r0,226r36,0r0,48r-90,0r0,-7v-6,3,-12,6,-19,8v-7,2,-13,3,-20,3v-14,0,-27,-3,-39,-8v-12,-5,-22,-11,-30,-20v-8,-9,-14,-19,-19,-31v-5,-12,-7,-24,-7,-37v0,-13,2,-26,7,-38v5,-12,11,-21,19,-30v8,-9,18,-15,30,-20v12,-5,24,-8,38,-8v8,0,14,2,21,3v7,1,13,3,19,6r0,-46r-25,0r0,-49xm111,-45v8,0,15,-2,21,-6v6,-4,11,-9,15,-15r0,-53v-4,-6,-9,-12,-16,-15v-7,-3,-13,-5,-20,-5v-6,0,-12,1,-17,3v-5,2,-10,6,-14,10v-4,4,-8,9,-10,15v-2,6,-4,12,-4,19v0,7,2,13,4,19v2,6,6,11,10,15v4,4,9,7,14,9v5,2,11,4,17,4","w":246},"e":{"d":"61,-80r1,6v1,5,3,10,6,14v3,4,7,7,11,10v4,3,10,5,15,6v5,1,10,2,15,2v5,0,10,0,15,-1v5,-1,10,-2,14,-3v4,-1,9,-3,13,-4v6,-2,6,-2,13,-4r19,36v-7,4,-12,7,-18,10v-6,3,-11,5,-17,7v-6,2,-12,3,-18,4v-6,1,-14,2,-22,2v-16,0,-30,-3,-42,-8v-12,-5,-23,-12,-31,-21v-8,-9,-15,-20,-19,-32v-4,-12,-7,-25,-7,-38v0,-13,2,-25,7,-37v5,-12,12,-22,20,-31v8,-9,18,-15,30,-20v12,-5,25,-8,39,-8v14,0,27,2,38,7v11,5,20,12,28,20v8,8,13,18,17,29v4,11,7,24,7,37v0,3,1,5,1,8v0,3,-1,6,-1,9r-134,0xm103,-146v-7,0,-11,0,-16,2v-5,2,-9,4,-12,7v-3,3,-6,5,-8,9v-2,4,-3,7,-4,11r76,0v-1,-4,-1,-7,-3,-11v-2,-4,-4,-6,-7,-9v-3,-3,-6,-5,-10,-7v-4,-2,-10,-2,-16,-2","w":208},"f":{"d":"93,-182r33,0r0,46r-33,0r0,88r34,0r0,48r-113,0r0,-48r27,0r0,-88r-28,0r0,-46r28,0r0,-30v0,-11,2,-20,6,-28v4,-8,9,-15,15,-21v6,-6,13,-9,21,-12v8,-3,17,-5,26,-5v7,0,13,1,18,2v5,1,10,2,14,4v4,2,7,3,10,5v3,2,5,3,7,5r-21,37v-3,-2,-6,-4,-9,-5v-3,-1,-7,-2,-12,-2v-3,0,-6,1,-9,2v-3,1,-5,2,-7,4v-2,2,-4,5,-5,8v-1,3,-2,6,-2,10r0,26","w":143,"k":{".":9,",":16}},"g":{"d":"149,-9v-7,4,-12,6,-19,8v-7,2,-13,2,-20,2v-14,0,-27,-2,-39,-7v-12,-5,-22,-12,-31,-20v-9,-8,-15,-18,-20,-30v-5,-12,-7,-24,-7,-38v0,-13,2,-25,7,-36v5,-11,11,-22,19,-30v8,-8,18,-15,30,-20v12,-5,24,-8,38,-8v8,0,16,1,23,3v7,2,13,4,19,7r0,-4r53,0r0,174v0,15,-2,29,-7,40v-5,11,-13,21,-22,28v-9,7,-18,12,-30,16v-12,4,-24,6,-37,6v-16,0,-31,-3,-45,-7v-14,-4,-25,-10,-36,-17r22,-39v8,5,18,9,27,12v9,3,19,4,31,4v6,0,13,-1,18,-2v5,-1,10,-4,14,-7v4,-3,7,-7,9,-13v2,-6,3,-13,3,-22r0,0xm111,-48v8,0,16,-2,23,-6v7,-4,11,-9,15,-16r1,-45v-4,-7,-10,-13,-17,-17v-7,-4,-14,-7,-22,-7v-6,0,-11,2,-17,4v-6,2,-10,5,-14,9v-4,4,-8,9,-10,14v-2,5,-4,11,-4,18v0,7,2,13,4,19v2,6,5,11,9,15v4,4,10,7,15,9v5,2,11,3,17,3","w":227},"h":{"d":"10,-274r82,0r0,109v7,-6,15,-11,23,-15v8,-4,17,-5,27,-5v22,0,38,6,50,18v12,12,18,30,18,54r0,65r27,0r0,48r-82,0r0,-101v0,-10,-2,-18,-7,-24v-5,-6,-12,-9,-20,-9v-5,0,-11,1,-17,4v-6,3,-13,7,-19,13r0,69r27,0r0,48r-109,0r0,-48r28,0r0,-177r-28,0r0,-49","w":243},"i":{"d":"14,-182r82,0r0,134r25,0r0,48r-107,0r0,-48r27,0r0,-86r-27,0r0,-48xm39,-241v0,-4,0,-8,2,-12v2,-4,4,-7,7,-10v3,-3,6,-5,10,-7v4,-2,8,-2,12,-2v4,0,8,0,12,2v4,2,7,4,10,7v3,3,4,6,6,10v2,4,3,8,3,12v0,4,-1,8,-3,12v-2,4,-3,7,-6,10v-3,3,-6,5,-10,7v-4,2,-8,2,-12,2v-4,0,-8,0,-12,-2v-4,-2,-7,-4,-10,-7v-3,-3,-5,-6,-7,-10v-2,-4,-2,-8,-2,-12","w":138},"j":{"d":"9,-182r80,0r0,185v0,14,-2,26,-5,36v-3,10,-8,19,-15,25v-7,6,-15,11,-25,14v-10,3,-20,4,-33,4r-1,-39v8,0,15,-5,19,-11v4,-6,6,-14,6,-25r0,-141r-26,0r0,-48xm32,-241v0,-4,0,-8,2,-12v2,-4,4,-7,7,-10v3,-3,6,-5,10,-7v4,-2,8,-2,12,-2v4,0,8,0,12,2v4,2,7,4,10,7v3,3,5,6,7,10v2,4,3,8,3,12v0,4,-1,8,-3,12v-2,4,-4,7,-7,10v-3,3,-6,5,-10,7v-4,2,-8,2,-12,2v-4,0,-8,0,-12,-2v-4,-2,-7,-4,-10,-7v-3,-3,-5,-6,-7,-10v-2,-4,-2,-8,-2,-12","w":109},"k":{"d":"10,-274r82,0r0,158r31,0r13,-18r0,-48r94,0r0,48r-33,0r-34,39r35,42r30,0r0,53r-49,0r-59,-78r-28,0r0,30r19,0r0,48r-101,0r0,-48r28,0r0,-177r-28,0r0,-49","w":254,"k":{"e":9,"c":9}},"l":{"d":"10,-274r82,0r0,226r29,0r0,48r-111,0r0,-48r28,0r0,-177r-28,0r0,-49","w":137},"m":{"d":"14,-182r84,0r0,16v8,-6,16,-11,25,-15v9,-4,19,-5,29,-5v14,0,26,2,36,7v10,5,17,13,23,23v4,-4,8,-8,13,-12v5,-4,10,-6,16,-9v6,-3,11,-6,17,-7v6,-1,12,-2,18,-2v22,0,40,7,52,19v12,12,18,30,18,54r0,65r26,0r0,48r-84,0r0,-104v0,-10,-3,-19,-8,-25v-5,-6,-13,-8,-22,-8v-7,0,-12,1,-18,4v-6,3,-12,8,-18,16r0,4r0,4r0,61r27,0r0,48r-83,0r0,-105v0,-5,-1,-9,-3,-13v-2,-4,-3,-7,-6,-10v-3,-3,-5,-5,-9,-7v-4,-2,-9,-2,-13,-2v-6,0,-12,0,-18,3v-6,3,-12,8,-18,15r0,71r29,0r0,48r-113,0r0,-48r27,0r0,-86r-27,0r0,-48","w":378},"n":{"d":"164,-105v0,-10,-3,-18,-8,-24v-5,-6,-13,-8,-22,-8v-6,0,-12,1,-18,4v-6,3,-12,8,-18,15r0,70r29,0r0,48r-113,0r0,-48r27,0r0,-86r-27,0r0,-48r83,0r0,16v8,-6,17,-11,26,-14v9,-3,20,-5,30,-5v22,0,38,6,50,18v12,12,18,30,18,54r0,65r26,0r0,48r-83,0r0,-105","w":256},"o":{"d":"13,-92v0,-13,2,-25,7,-37v5,-12,11,-21,20,-30v9,-9,18,-16,30,-21v12,-5,26,-8,40,-8v14,0,27,3,39,8v12,5,21,12,30,21v9,9,15,18,20,30v5,12,7,24,7,37v0,13,-2,26,-7,38v-5,12,-11,21,-19,30v-8,9,-19,16,-31,21v-12,5,-24,7,-39,7v-15,0,-28,-2,-40,-7v-12,-5,-23,-12,-31,-21v-8,-9,-14,-18,-19,-30v-5,-12,-7,-25,-7,-38xm65,-92v0,7,2,13,4,19v2,6,5,11,9,15v4,4,9,8,14,10v5,2,12,4,18,4v6,0,12,-2,17,-4v5,-2,10,-5,14,-9v4,-4,7,-10,9,-16v2,-6,3,-12,3,-19v0,-7,-1,-13,-3,-19v-2,-6,-5,-11,-9,-15v-4,-4,-9,-8,-14,-10v-5,-2,-11,-3,-17,-3v-6,0,-13,1,-18,3v-5,2,-10,6,-14,10v-4,4,-7,9,-9,15v-2,6,-4,12,-4,19"},"p":{"d":"21,-182r79,0r0,3v6,-2,12,-5,18,-6v6,-1,12,-3,18,-3v13,0,26,3,37,8v11,5,22,12,30,21v8,9,15,18,20,30v5,12,7,24,7,37v0,13,-2,25,-7,37v-5,12,-12,21,-20,30v-8,9,-17,16,-29,21v-12,5,-24,7,-38,7v-8,0,-15,-1,-22,-2v-7,-1,-13,-3,-19,-6r0,40r35,0r0,48r-119,0r0,-48r30,0r0,-169r-20,0r0,-48xm132,-139v-7,0,-15,2,-21,6v-6,4,-12,9,-16,16r0,51v4,6,9,11,15,15v6,4,14,6,22,6v6,0,12,-2,17,-4v5,-2,10,-5,14,-9v4,-4,7,-9,9,-15v2,-6,4,-12,4,-19v0,-7,-1,-14,-3,-20v-2,-6,-6,-10,-10,-14v-4,-4,-9,-8,-14,-10v-5,-2,-11,-3,-17,-3","w":240},"q":{"d":"107,35r37,0r0,-42v-6,3,-13,6,-19,8v-6,2,-12,3,-19,3v-14,0,-27,-3,-39,-8v-12,-5,-22,-12,-30,-21v-8,-9,-14,-18,-19,-30v-5,-12,-7,-25,-7,-38v0,-13,2,-26,7,-37v5,-11,11,-21,19,-30v8,-9,18,-15,30,-20v12,-5,24,-8,38,-8v7,0,14,2,21,3v7,1,12,3,18,6r0,-9r54,0r0,223r27,0r0,48r-118,0r0,-48xm109,-45v7,0,14,-2,20,-5v6,-3,11,-8,15,-14r0,-57v-4,-6,-9,-10,-15,-13v-6,-3,-13,-5,-20,-5v-6,0,-12,1,-17,3v-5,2,-10,6,-14,10v-4,4,-8,9,-10,15v-2,6,-3,12,-3,19v0,7,1,13,3,19v2,6,6,11,10,15v4,4,9,7,14,9v5,2,11,4,17,4","w":234},"r":{"d":"179,-116r-49,0r0,-19v-5,0,-9,0,-13,1v-4,1,-8,2,-11,4v-3,2,-5,3,-7,6v-2,3,-4,6,-5,10r0,66r37,0r0,48r-118,0r0,-48r27,0r0,-86r-27,0r0,-48r81,0r0,13v5,-4,11,-8,17,-10v6,-2,14,-3,22,-3r23,0r23,0r0,66","w":195},"s":{"d":"128,-134v-2,-3,-4,-5,-8,-7v-4,-2,-8,-4,-13,-5v-5,-1,-12,-2,-18,-2v-2,0,-5,1,-8,1v-3,0,-5,1,-7,2v-2,1,-4,2,-6,4v-2,2,-3,4,-3,7v0,1,1,3,1,4v0,1,1,3,2,4v1,1,3,2,5,3v2,1,5,2,8,3r33,6v12,2,22,5,30,9v8,4,15,7,20,12v5,5,8,10,10,16v2,6,4,12,4,19v0,10,-3,19,-8,27v-5,8,-11,15,-19,20v-8,5,-17,8,-27,11v-10,3,-20,4,-30,4v-7,0,-12,0,-17,-1v-5,-1,-11,-2,-15,-3v-4,-1,-8,-3,-11,-5r-10,-7r-31,0r0,-48r49,0r0,1v0,3,2,5,4,8v2,3,4,5,7,7v3,2,7,3,11,4v4,1,8,1,13,1v11,0,18,-1,23,-4v5,-3,8,-7,8,-11v0,-3,-2,-6,-4,-8v-2,-2,-6,-5,-12,-6r-34,-7v-21,-4,-37,-11,-48,-21v-11,-10,-16,-22,-16,-37v0,-9,2,-17,6,-24v4,-7,10,-13,17,-18v7,-5,15,-9,24,-12v9,-3,20,-4,31,-4v7,0,13,0,19,1v6,1,11,3,16,4v5,1,9,3,12,5r9,6r31,0r0,49r-46,0v0,-3,0,-5,-2,-8","w":193},"t":{"d":"83,-182r36,0r0,46r-37,0r0,77v0,4,0,8,1,11v1,3,2,4,3,6v1,2,3,3,5,4v2,1,5,1,7,1v4,0,8,-1,11,-2v3,-1,8,-2,11,-3r7,34v-6,4,-13,7,-20,9v-7,2,-16,3,-26,3v-7,0,-13,-1,-20,-3v-7,-2,-13,-6,-18,-11v-5,-5,-8,-11,-11,-19v-3,-8,-5,-16,-5,-26r1,-81r-26,0r0,-46r26,0r0,-44r55,-26r0,70","w":140},"u":{"d":"127,-182r86,0r0,134r22,0r0,48r-77,0r0,-15v-6,6,-14,10,-22,13v-8,3,-18,4,-29,4v-10,0,-19,-2,-28,-5v-9,-3,-16,-8,-23,-14v-7,-6,-12,-14,-16,-24v-4,-10,-6,-21,-6,-34r0,-59r-23,0r0,-48r80,0r0,107v0,12,3,21,9,27v6,6,15,10,25,10v7,0,13,-3,19,-7v6,-4,9,-11,12,-18r0,-71r-29,0r0,-48","w":247},"v":{"d":"7,-182r95,0r0,48r-22,0r30,78r29,-78r-20,0r0,-48r95,0r0,48r-24,0r-55,135r-53,0r-55,-135r-20,0r0,-48","w":220},"w":{"d":"7,-182r95,0r0,48r-20,0r19,65r38,-113r51,0r38,119r23,-71r-19,0r0,-48r95,0r0,48r-25,0r-49,135r-52,0r-38,-116r-39,116r-51,0r-45,-135r-21,0r0,-48","w":333},"x":{"d":"121,-48r10,0r-23,-22r-23,22r12,0r0,48r-86,0r0,-48r18,0r45,-44r-42,-42r-21,0r0,-48r86,0r0,48r-9,0r22,19r20,-19r-10,0r0,-48r86,0r0,48r-20,0r-42,42r44,44r18,0r0,48r-85,0r0,-48","w":217},"y":{"d":"9,-182r89,0r0,48r-14,0r26,68r27,-68r-15,0r0,-48r89,0r0,48r-20,0r-70,169r31,0r0,48r-113,0r0,-48r32,0r13,-35r-57,-134r-18,0r0,-48","k":{".":35,",":26}},"z":{"d":"17,-29r75,-106r-35,0r0,27r-46,0r0,-74r159,0r0,32r-79,103r40,0r0,-35r47,0r0,82r-161,0r0,-29","w":200},",":{"d":"36,-50r54,19r-50,95r-36,-14","w":93},"-":{"d":"11,-79r0,-48r110,0r0,48r-110,0","w":135},".":{"d":"12,-28v0,-5,1,-10,3,-14v2,-4,4,-8,7,-11v3,-3,7,-5,11,-7v4,-2,9,-3,14,-3v5,0,9,1,13,3v4,2,8,4,11,7v3,3,5,7,7,11v2,4,3,9,3,14v0,5,-1,9,-3,13v-2,4,-5,8,-8,11v-3,3,-6,5,-10,7v-4,2,-8,3,-13,3v-5,0,-10,-1,-14,-3v-4,-2,-8,-4,-11,-7v-3,-3,-5,-7,-7,-11v-2,-4,-3,-8,-3,-13","w":92},"0":{"d":"118,2v-19,0,-35,-3,-48,-10v-13,-7,-24,-16,-32,-28v-8,-12,-14,-27,-18,-43v-4,-16,-6,-35,-6,-54v0,-19,2,-36,6,-53v4,-17,10,-31,18,-43v8,-12,19,-23,32,-30v13,-7,29,-11,48,-11v19,0,36,4,49,11v13,7,24,17,32,29v8,12,14,27,18,43v4,16,5,34,5,53v0,19,-2,36,-6,53v-4,17,-10,32,-18,44v-8,12,-19,22,-32,29v-13,7,-29,10,-48,10xm118,-52v10,0,19,-2,25,-6v6,-4,11,-10,14,-17v3,-7,5,-16,6,-26v1,-10,2,-21,2,-33v0,-12,-1,-22,-2,-32v-1,-10,-3,-20,-6,-27v-3,-7,-8,-13,-14,-17v-6,-4,-15,-6,-25,-6v-10,0,-18,2,-24,6v-6,4,-12,10,-15,17v-3,7,-5,17,-6,27v-1,10,-2,20,-2,32v0,12,1,23,2,33v1,10,3,19,6,26v3,7,8,13,14,17v6,4,15,6,25,6","w":227},"1":{"d":"20,-48r28,0r0,-139r-41,24r0,-61r74,-43r25,0r0,219r28,0r0,48r-114,0r0,-48","w":143},"2":{"d":"22,-46r92,-98v8,-8,15,-15,19,-23v4,-8,6,-15,6,-23v0,-3,-1,-7,-2,-10v-1,-3,-3,-6,-6,-9v-3,-3,-5,-5,-9,-7v-4,-2,-8,-2,-13,-2v-6,0,-11,1,-15,3v-4,2,-8,4,-11,7v-3,3,-5,7,-7,11v-2,4,-2,8,-2,13r-53,0v0,-14,2,-26,7,-37v5,-11,11,-20,19,-27v8,-7,17,-13,28,-17v11,-4,23,-6,35,-6v12,0,23,2,33,6v10,4,19,8,27,15v8,7,14,15,19,25v5,10,8,22,8,35v0,10,-3,20,-7,29v-4,9,-10,17,-17,25r-76,82r99,0r0,54r-174,0r0,-46","w":207},"3":{"d":"128,-190v0,-4,-1,-7,-3,-11v-2,-4,-3,-6,-6,-9v-3,-3,-7,-5,-11,-7v-4,-2,-9,-3,-14,-3v-4,0,-8,1,-12,2v-4,1,-8,4,-11,6v-3,2,-5,6,-7,9v-2,3,-2,8,-2,16r-55,0v0,-11,2,-23,6,-33v4,-10,10,-19,18,-27v8,-8,16,-14,27,-19v11,-5,23,-6,36,-6v12,0,24,2,35,6v11,4,20,10,28,17v8,7,14,16,19,25v5,9,6,20,6,30v0,11,-2,22,-7,31v-5,9,-11,17,-19,23v4,2,8,5,12,9v4,4,7,9,10,14v3,5,4,10,6,16v2,6,3,12,3,19v0,11,-3,23,-8,33v-5,10,-11,19,-19,27v-8,8,-18,13,-29,18v-11,5,-24,7,-37,7v-12,0,-23,-2,-34,-6v-11,-4,-20,-9,-28,-16v-8,-7,-14,-15,-19,-24v-5,-9,-8,-17,-9,-23v-1,-6,-1,-13,-1,-20r55,0v1,12,5,22,11,28v6,6,15,8,26,8v5,0,10,0,14,-2v4,-2,9,-4,12,-7v3,-3,6,-6,8,-10v2,-4,2,-9,2,-13v0,-5,0,-9,-2,-13v-2,-4,-4,-7,-7,-10v-3,-3,-7,-5,-12,-7v-5,-2,-9,-2,-15,-2r-25,0r0,-48r25,0v5,0,10,-2,14,-3v4,-1,7,-3,10,-5v3,-2,6,-6,7,-9v1,-3,2,-7,2,-11","w":191},"4":{"d":"2,-118r95,-148r58,0r-93,149r56,0r0,-52r55,-1r0,53r37,0r0,44r-37,0r0,25r34,0r0,48r-114,0r0,-48r25,0r0,-25r-116,0r0,-45","w":216},"5":{"d":"77,-163v6,-2,11,-4,18,-5v7,-1,13,-2,21,-2v12,0,23,1,34,5v11,4,20,10,28,17v8,7,15,15,20,26v5,11,7,23,7,37v0,15,-3,28,-8,39v-5,11,-12,20,-21,28v-9,8,-19,14,-30,18v-11,4,-22,5,-34,5v-11,0,-22,-1,-32,-4v-10,-3,-20,-7,-28,-13v-8,-6,-15,-14,-21,-23v-6,-9,-9,-19,-11,-31r54,-15v1,6,2,11,4,15v2,4,6,8,9,11v3,3,7,5,11,7v4,2,9,2,14,2v6,0,11,-1,16,-3v5,-2,9,-5,12,-9v3,-4,5,-7,7,-12v2,-5,3,-10,3,-16v0,-5,-1,-10,-3,-15v-2,-5,-4,-8,-8,-12v-4,-4,-7,-6,-12,-8v-5,-2,-11,-3,-17,-3v-8,0,-14,1,-20,2v-6,1,-11,3,-17,6r-47,-9r0,-141r169,0r0,53r-118,0r0,50","w":211},"6":{"d":"160,-267r-54,95r9,0v0,0,6,1,9,2v10,2,19,5,28,10v9,5,17,11,23,18v6,7,11,16,15,25v4,9,5,20,5,30v0,13,-2,24,-7,35v-5,11,-12,21,-20,29v-8,8,-18,13,-29,18v-11,5,-23,7,-36,7v-12,0,-24,-2,-35,-7v-11,-5,-21,-10,-29,-18v-8,-8,-15,-17,-20,-28v-5,-11,-7,-22,-7,-34v0,-6,0,-12,1,-17v1,-5,3,-11,5,-16v2,-5,4,-10,7,-15v4,-7,4,-7,8,-15r66,-119r61,0xm102,-122v-7,0,-13,1,-19,4v-6,3,-10,6,-14,11v-2,3,-3,7,-4,10v-1,3,-2,7,-2,11v0,4,1,9,3,13v2,4,4,7,7,11v3,4,7,7,12,9v5,2,11,4,18,4v5,0,10,-1,15,-3v5,-2,8,-4,12,-7v4,-3,8,-6,10,-11v2,-5,3,-10,3,-16v0,-6,-1,-11,-3,-15v-2,-4,-5,-8,-9,-11v-4,-3,-8,-5,-13,-7v-5,-2,-10,-3,-16,-3","w":204},"7":{"d":"40,-48r19,0r18,-42r19,-43v0,0,10,-21,19,-41r17,-38r-74,0r0,31r-51,0r0,-85r195,0r0,39r-42,88v0,0,-22,45,-42,91r17,0r0,48r-95,0r0,-48","w":209},"8":{"d":"112,-271v12,0,23,2,34,6v11,4,20,10,28,17v8,7,13,16,18,25v5,9,7,19,7,30v0,10,-2,20,-7,29v-5,9,-11,17,-19,24v10,7,17,16,23,26v6,10,9,21,9,33v0,11,-2,23,-7,33v-5,10,-12,19,-20,27v-8,8,-18,14,-29,19v-11,5,-24,7,-37,7v-9,0,-17,-2,-25,-4v-8,-2,-15,-5,-22,-9v-7,-4,-13,-8,-19,-13v-6,-5,-10,-12,-14,-18v-4,-6,-7,-13,-9,-20v-2,-7,-3,-14,-3,-21v0,-12,3,-24,9,-34v6,-10,13,-19,23,-26v-8,-7,-14,-15,-19,-24v-5,-9,-7,-18,-7,-28v0,-11,2,-21,7,-31v5,-10,11,-18,19,-25v8,-7,17,-13,27,-17v10,-4,21,-6,33,-6xm71,-82v0,5,1,10,3,14v2,4,5,8,9,11v4,3,8,6,13,8v5,2,10,3,16,3v6,0,11,-1,16,-3v5,-2,9,-5,13,-8v4,-3,7,-7,9,-11v2,-4,3,-9,3,-14v0,-5,-1,-9,-3,-13v-2,-4,-5,-8,-9,-11v-4,-3,-8,-6,-13,-8v-5,-2,-10,-2,-16,-2v-6,0,-11,0,-16,2v-5,2,-9,5,-13,8v-4,3,-7,7,-9,11v-2,4,-3,8,-3,13xm77,-190v0,4,1,7,3,11v2,4,4,7,7,10v3,3,8,4,12,6v4,2,8,3,13,3v5,0,10,-1,14,-3v4,-2,8,-3,11,-6v3,-3,6,-6,8,-10v2,-4,3,-7,3,-11v0,-4,-1,-8,-3,-12v-2,-4,-5,-6,-8,-9v-3,-3,-7,-5,-11,-7v-4,-2,-9,-3,-14,-3v-5,0,-9,1,-13,3v-4,2,-9,4,-12,7v-3,3,-5,5,-7,9v-2,4,-3,8,-3,12","w":207},"9":{"d":"54,0r54,-95r-10,0v0,0,-5,0,-8,-1v-10,-2,-19,-5,-28,-10v-9,-5,-17,-12,-23,-19v-6,-7,-11,-16,-15,-25v-4,-9,-5,-19,-5,-29v0,-13,2,-25,7,-36v5,-11,12,-20,20,-28v8,-8,18,-14,29,-19v11,-5,23,-7,36,-7v12,0,24,2,35,7v11,5,22,11,30,19v8,8,14,16,19,27v5,11,8,23,8,35v0,6,-1,12,-2,17v-1,5,-3,10,-5,15v-2,5,-4,10,-7,15v-4,7,-4,7,-8,15r-66,119r-61,0xm112,-144v7,0,13,-2,19,-4v6,-2,10,-6,14,-11v2,-3,3,-6,4,-10v1,-4,1,-7,1,-11v0,-4,0,-9,-2,-13v-2,-4,-4,-8,-7,-12v-3,-4,-7,-7,-12,-9v-5,-2,-11,-3,-18,-3v-5,0,-10,0,-15,2v-5,2,-8,4,-12,7v-4,3,-8,7,-10,12v-2,5,-3,9,-3,15v0,6,1,11,3,15v2,4,5,9,9,12v4,3,8,5,13,7v5,2,10,3,16,3","w":202},"!":{"d":"24,-25v0,-4,1,-9,3,-13v2,-4,3,-7,6,-10v3,-3,6,-4,10,-6v4,-2,9,-3,13,-3v4,0,8,1,12,3v4,2,7,3,10,6v3,3,4,6,6,10v2,4,3,9,3,13v0,4,-1,8,-3,12v-2,4,-3,7,-6,10v-3,3,-6,4,-10,6v-4,2,-8,3,-12,3v-4,0,-9,-1,-13,-3v-4,-2,-7,-3,-10,-6v-3,-3,-4,-6,-6,-10v-2,-4,-3,-8,-3,-12xm24,-277r65,0r-7,187r-50,0","w":122},"%":{"d":"37,-205v0,-9,2,-17,5,-25v3,-8,8,-15,14,-21v6,-6,13,-11,21,-14v8,-3,17,-5,27,-5v10,0,19,2,27,5v8,3,15,8,21,14v6,6,10,13,13,21v3,8,5,16,5,25v0,9,-2,17,-5,25v-3,8,-7,14,-13,20v-6,6,-13,10,-21,14v-8,4,-17,6,-27,6v-10,0,-20,-3,-28,-6v-8,-3,-15,-8,-21,-14v-6,-6,-10,-12,-13,-20v-3,-8,-5,-16,-5,-25xm104,-229v-3,0,-7,0,-10,1v-3,1,-6,3,-8,5v-2,2,-4,5,-5,8v-1,3,-2,6,-2,10v0,3,1,6,2,9v1,3,3,6,5,8v2,2,5,4,8,5v3,1,7,2,10,2v3,0,6,-1,9,-2v3,-1,6,-3,8,-5v2,-2,4,-5,5,-8v1,-3,2,-6,2,-9v0,-4,-1,-7,-2,-10v-1,-3,-3,-6,-5,-8v-2,-2,-5,-4,-8,-5v-3,-1,-6,-1,-9,-1xm241,-271r47,0r-181,271r-46,0xm180,-67v0,-9,2,-17,5,-25v3,-8,8,-14,14,-20v6,-6,13,-11,21,-14v8,-3,17,-5,27,-5v10,0,18,2,26,5v8,3,16,8,22,14v6,6,10,12,13,20v3,8,5,16,5,25v0,9,-2,17,-5,25v-3,8,-7,15,-13,21v-6,6,-13,10,-21,14v-8,4,-17,5,-27,5v-10,0,-20,-2,-28,-5v-8,-3,-15,-8,-21,-14v-6,-6,-10,-13,-13,-21v-3,-8,-5,-16,-5,-25xm247,-91v-3,0,-7,1,-10,2v-3,1,-6,3,-8,5v-2,2,-4,5,-5,8v-1,3,-2,5,-2,9v0,3,1,7,2,10v1,3,3,6,5,8v2,2,5,4,8,5v3,1,7,2,10,2v3,0,6,-1,9,-2v3,-1,6,-3,8,-5v2,-2,4,-5,5,-8v1,-3,2,-7,2,-10v0,-4,-1,-6,-2,-9v-1,-3,-3,-6,-5,-8v-2,-2,-5,-4,-8,-5v-3,-1,-6,-2,-9,-2","w":322},"&":{"d":"210,9r-35,-37v-10,9,-21,17,-33,22v-12,5,-25,8,-40,8v-12,0,-24,-2,-34,-6v-10,-4,-19,-10,-27,-17v-8,-7,-15,-16,-19,-26v-4,-10,-6,-21,-6,-33v0,-15,3,-29,10,-40v7,-11,17,-21,29,-30r1,0r-4,-4v-7,-8,-13,-16,-17,-25v-4,-9,-5,-19,-5,-30v0,-10,1,-19,5,-28v4,-9,9,-16,16,-23v7,-7,15,-11,24,-15v9,-4,19,-6,30,-6v11,0,22,2,31,6v9,4,17,9,24,16v7,7,11,14,15,23v4,9,6,17,6,26v0,7,-1,13,-3,19v-2,6,-4,13,-7,18v-3,5,-6,10,-10,14v-4,4,-9,8,-13,11r-6,4v-2,1,-4,3,-6,4r29,29v2,-5,3,-10,4,-15v1,-5,2,-10,3,-14r53,0v-1,11,-3,23,-6,35v-3,12,-8,23,-13,34r45,44xm71,-81v0,4,1,7,3,11v2,4,3,7,6,10v3,3,6,4,10,6v4,2,8,3,13,3v7,0,14,-1,20,-4v6,-3,11,-6,16,-10r-47,-47v-3,2,-5,4,-8,6v-3,2,-5,5,-7,7v-2,2,-3,5,-4,8v-1,3,-2,6,-2,10xm118,-187v4,-3,6,-5,8,-9v2,-4,3,-9,3,-14v0,-3,-1,-5,-2,-8v-1,-3,-3,-6,-5,-8v-2,-2,-5,-4,-8,-5v-3,-1,-6,-2,-9,-2v-4,0,-7,1,-10,2v-3,1,-6,3,-8,5v-2,2,-4,4,-5,7v-1,3,-2,6,-2,9v0,5,1,10,3,14v2,4,4,8,7,11r10,10r10,-6v3,-2,6,-4,8,-6","w":235},"'":{"d":"45,-186r-38,0r0,-91r50,-3","w":59},"\"":{"d":"51,-186r-37,0r-7,-91r47,0xm103,-186r-35,0r-2,-91r46,0","w":114},"(":{"d":"90,82v-11,-14,-22,-29,-31,-44v-9,-15,-16,-31,-22,-48v-6,-17,-10,-34,-13,-51v-3,-17,-5,-35,-5,-53v0,-36,6,-70,18,-104v12,-34,30,-65,53,-93r44,30v-9,12,-18,25,-25,38v-7,13,-13,27,-18,41v-5,14,-8,29,-11,44v-3,15,-4,29,-4,44v0,15,1,30,4,45v3,15,6,30,11,44v5,14,11,28,18,41v7,13,15,26,24,38","w":126},")":{"d":"1,52v9,-12,17,-25,24,-38v7,-13,13,-27,18,-41v5,-14,8,-29,11,-44v3,-15,4,-29,4,-44v0,-15,-1,-30,-4,-45v-3,-15,-6,-30,-11,-44v-5,-14,-11,-28,-18,-41v-7,-13,-15,-26,-24,-38r44,-28v23,28,40,59,52,92v12,33,18,68,18,104v0,36,-6,70,-18,104v-12,34,-30,65,-53,93","w":126},"*":{"d":"111,-240r42,-13r13,41r-42,14r26,36r-36,26r-26,-36r-25,36r-36,-26r26,-36r-42,-14r13,-41r43,13r0,-44r44,0r0,44","w":177},"+":{"d":"18,-129r64,0r0,-64r52,0r0,64r64,0r0,52r-64,0r0,64r-52,0r0,-64r-64,0r0,-52","w":216},"\/":{"d":"111,-274r45,0r-101,274r-46,0","w":141},"@":{"d":"283,-168r0,114v0,5,1,9,3,12v2,3,4,5,8,5v6,0,11,-1,15,-5v4,-4,7,-8,9,-14v2,-6,3,-12,4,-19v1,-7,1,-13,1,-20v0,-10,-1,-20,-4,-29v-3,-9,-7,-19,-12,-27v-5,-8,-12,-16,-19,-23v-7,-7,-16,-13,-25,-18v-9,-5,-19,-9,-29,-12v-10,-3,-22,-4,-33,-4v-11,0,-22,1,-32,4v-10,3,-20,7,-29,12v-9,5,-18,12,-25,19v-7,7,-13,16,-18,25v-5,9,-10,19,-13,29v-3,10,-4,21,-4,32v0,17,3,33,9,48v6,15,15,27,26,38v11,11,24,20,39,26v15,6,30,10,47,10v12,0,24,-2,35,-6v11,-4,23,-8,34,-15r24,40v-15,9,-30,15,-46,20v-16,5,-31,7,-47,7v-15,0,-30,-2,-44,-6v-14,-4,-29,-9,-41,-16v-12,-7,-24,-17,-34,-27v-10,-10,-19,-22,-26,-34v-7,-12,-13,-26,-17,-40v-4,-14,-6,-29,-6,-45v0,-15,2,-30,6,-44v4,-14,10,-29,17,-41v7,-12,16,-23,26,-33v10,-10,22,-20,34,-27v12,-7,27,-13,41,-17v14,-4,29,-6,44,-6v16,0,31,2,45,6v14,4,29,10,41,17v12,7,24,15,34,25v10,10,19,20,26,32v7,12,13,25,17,38v4,13,6,28,6,42v0,12,-2,23,-6,35v-4,12,-8,23,-15,32v-7,9,-16,16,-26,22v-10,6,-22,9,-35,9v-9,0,-17,-2,-24,-5v-7,-3,-13,-8,-18,-14v-7,6,-15,11,-23,14v-8,3,-16,5,-24,5v-13,0,-25,-2,-36,-7v-11,-5,-20,-11,-28,-19v-8,-8,-15,-18,-19,-28v-4,-10,-6,-21,-6,-33v0,-11,2,-23,6,-33v4,-10,10,-19,18,-27v8,-8,17,-14,27,-19v10,-5,21,-7,34,-7v7,0,14,1,20,2v6,1,11,3,17,5r0,-5r51,0xm199,-49v7,0,13,-1,19,-5v6,-4,10,-9,14,-16r0,-28r-6,-9v0,0,-4,-5,-7,-7v-3,-2,-7,-4,-10,-5v-3,-1,-6,-2,-10,-2v-5,0,-10,1,-14,3v-4,2,-9,5,-12,8v-3,3,-5,8,-7,12v-2,4,-3,9,-3,14v0,5,1,10,3,14v2,4,4,9,7,12v3,3,8,5,12,7v4,2,9,2,14,2","w":398},"[":{"d":"14,-283r97,0r0,43r-40,0r0,286r40,0r0,44r-97,0r0,-373","w":117},"\\":{"d":"1,-243r42,0r100,295r-43,0","w":136},"]":{"d":"47,-240r-39,0r0,-43r96,0r0,373r-96,0r0,-44r39,0r0,-286","w":117},"#":{"d":"29,-211r32,0r11,-55r58,0r-11,55r58,0r11,-55r58,0r-11,55r28,0r-11,50r-27,0r-12,62r33,0r-11,50r-31,0r-10,49r-59,0r10,-49r-57,0r-9,49r-59,0r9,-49r-28,0r12,-50r26,0r12,-62r-33,0xm98,-99r57,0r12,-62r-57,0","w":270},"<":{"d":"5,-118r133,-49r0,45r-79,24r79,25r0,44r-133,-50r0,-39","w":152},"=":{"d":"11,-100r153,0r0,51r-153,0r0,-51xm11,-175r153,0r0,50r-153,0r0,-50","w":174},">":{"d":"140,-79r-133,50r0,-44r79,-25r-79,-24r0,-45r133,49r0,39","w":145},"?":{"d":"53,-25v0,-4,0,-9,2,-13v2,-4,4,-7,7,-10v3,-3,6,-4,10,-6v4,-2,8,-3,12,-3v4,0,8,1,12,3v4,2,7,3,10,6v3,3,5,6,7,10v2,4,2,9,2,13v0,4,0,8,-2,12v-2,4,-4,7,-7,10v-3,3,-6,4,-10,6v-4,2,-8,3,-12,3v-4,0,-8,-1,-12,-3v-4,-2,-7,-3,-10,-6v-3,-3,-5,-6,-7,-10v-2,-4,-2,-8,-2,-12xm57,-69r0,-21v0,0,1,-12,2,-17v1,-5,2,-9,3,-13v1,-4,4,-8,6,-11v2,-3,5,-6,9,-9r13,-10v0,0,9,-8,13,-12v4,-4,6,-7,8,-11v2,-4,3,-8,4,-12v1,-4,2,-8,2,-13v0,-7,-2,-12,-5,-16v-3,-4,-8,-7,-14,-7v-4,0,-8,0,-11,1v-3,1,-6,3,-8,5v-2,2,-4,5,-5,9v-1,4,-2,9,-2,15r-56,-6v0,-13,3,-23,7,-33v4,-10,10,-18,17,-24v7,-6,17,-11,27,-14v10,-3,21,-5,33,-5v11,0,21,2,31,5v10,3,18,9,25,15v7,6,13,14,17,23v4,9,7,21,7,33v0,13,-3,24,-9,35v-6,11,-15,21,-27,30v-6,4,-12,9,-16,13v-4,4,-7,7,-9,12v-2,5,-5,10,-6,16v-1,6,-1,13,-1,22r-55,0","w":209},"$":{"d":"81,33r0,-57v-6,-2,-13,-4,-18,-7v-5,-3,-10,-7,-14,-11r-31,0r0,-53r60,0v0,4,1,8,2,11v1,3,3,6,6,9v3,3,6,5,10,6v4,1,9,2,14,2v6,0,11,-1,14,-3v3,-2,4,-6,4,-10v0,-2,0,-3,-1,-5v-1,-2,-3,-3,-5,-4v-2,-1,-4,-3,-6,-4v-2,-1,-5,-1,-7,-2r-33,-10v-7,-2,-13,-5,-19,-8v-6,-3,-11,-7,-15,-12v-4,-5,-7,-10,-10,-16v-3,-6,-4,-14,-4,-22v0,-8,1,-15,4,-22v3,-7,6,-12,11,-17v5,-5,10,-9,17,-12v7,-3,13,-5,21,-7r0,-57r58,0r0,60v5,2,10,4,14,6v4,2,8,5,11,7r31,0r0,53r-60,0v0,-4,-1,-8,-2,-11v-1,-3,-3,-6,-5,-8v-2,-2,-5,-5,-9,-6v-4,-1,-7,-2,-12,-2v-6,0,-11,2,-14,4v-3,2,-4,4,-4,8v0,2,1,4,2,6v1,2,3,3,5,4v2,1,5,3,8,4r9,3r32,10v16,5,26,12,34,21v8,9,12,20,12,34v0,8,-2,15,-4,21v-2,6,-6,13,-10,18v-4,5,-10,10,-16,14v-6,4,-14,7,-22,9r0,56r-58,0"},"{":{"d":"18,-140v4,-1,8,-1,12,-1v4,0,7,-1,10,-1v3,0,6,-2,8,-3v2,-1,4,-3,6,-6v2,-3,3,-6,4,-11v1,-5,2,-11,2,-18r0,-70v0,-11,1,-21,3,-29v2,-8,6,-14,10,-19v4,-5,10,-8,17,-10v7,-2,14,-3,23,-3r14,0r11,0v0,0,6,1,9,1r0,54v-6,0,-10,1,-13,2v-3,1,-6,2,-8,4v-2,2,-3,5,-4,8v-1,3,-1,8,-1,13r0,72v0,4,0,8,-1,11v-1,3,-1,6,-2,9v-1,3,-3,5,-6,7v-3,2,-6,4,-10,6v4,2,7,4,10,7v3,3,5,5,6,8v1,3,3,7,3,10r0,10r0,66v0,6,0,10,1,14v1,4,2,7,4,9v2,2,5,3,8,4v3,1,7,1,13,1r0,58v-3,0,-6,1,-9,1r-11,0v0,0,-8,1,-14,1v-9,0,-16,-2,-23,-4v-7,-2,-13,-5,-17,-10v-4,-5,-8,-11,-10,-19v-2,-8,-3,-18,-3,-29r0,-83v-1,-7,-3,-13,-5,-16v-2,-3,-5,-6,-9,-7v-4,-1,-8,-2,-13,-2v-5,0,-10,-1,-15,-2r0,-33","w":157},"|":{"d":"22,-304r44,0r0,351r-44,0r0,-351","w":104},"}":{"d":"11,63r0,-58v6,0,10,0,13,-1v3,-1,6,-2,8,-4v2,-2,3,-5,4,-9v1,-4,0,-8,0,-14r0,-66v0,-4,1,-7,1,-10v0,-3,2,-7,3,-10v1,-3,3,-5,6,-8v3,-3,6,-5,10,-7v-4,-2,-7,-4,-10,-6v-3,-2,-5,-4,-6,-7r-3,-9v0,0,-1,-7,-1,-11r0,-72v0,-5,1,-10,0,-13v-1,-3,-2,-6,-4,-8v-2,-2,-5,-3,-8,-4v-3,-1,-7,-2,-13,-2r0,-54v3,0,6,-1,9,-1r10,0r15,0v7,0,14,1,20,2v6,1,11,4,15,7v4,3,7,7,10,12v3,5,6,11,7,19v1,3,1,7,1,10r0,11r0,56v0,10,0,19,1,25v1,6,2,11,3,15v1,4,4,6,6,8v2,2,5,2,8,3v3,1,6,2,10,2v4,0,9,0,14,1r0,33v-5,1,-10,2,-15,2v-5,0,-9,1,-13,2v-4,1,-7,4,-9,7v-2,3,-4,9,-5,16r0,83r0,11v0,0,0,7,-1,10v-1,8,-4,14,-7,19v-3,5,-6,9,-10,12v-4,3,-9,6,-15,7v-6,1,-13,3,-20,3v-6,0,-11,-1,-15,-1r-10,0v0,0,-6,-1,-9,-1","w":157},"~":{"d":"-1,-90v0,-4,-1,-8,0,-12r3,-12v0,0,4,-9,6,-13v2,-4,5,-7,9,-10v4,-3,7,-6,12,-8v5,-2,11,-3,17,-3v3,0,6,1,10,2v4,1,8,3,12,5v4,2,9,4,13,6r12,6v0,0,8,4,11,5v3,1,6,2,9,2v6,0,10,-2,13,-5v3,-3,4,-9,5,-16r32,8v0,5,-1,10,-2,17v-1,7,-4,13,-8,19v-4,6,-9,10,-16,14v-7,4,-14,7,-25,7v-6,0,-13,-2,-19,-5v-6,-3,-12,-5,-18,-8r-16,-9v-5,-3,-9,-4,-13,-4v-2,0,-5,0,-7,1v-2,1,-3,2,-5,4v-2,2,-3,3,-4,6v-1,3,-1,6,-1,10","w":159},":":{"d":"13,-159v0,-4,0,-9,2,-13v2,-4,4,-7,7,-10v3,-3,6,-4,10,-6v4,-2,8,-3,12,-3v4,0,8,1,12,3v4,2,7,3,10,6v3,3,4,6,6,10v2,4,3,9,3,13v0,4,-1,8,-3,12v-2,4,-3,7,-6,10v-3,3,-6,4,-10,6v-4,2,-8,3,-12,3v-4,0,-8,-1,-12,-3v-4,-2,-7,-3,-10,-6v-3,-3,-5,-6,-7,-10v-2,-4,-2,-8,-2,-12xm13,-25v0,-4,0,-9,2,-13v2,-4,4,-7,7,-10v3,-3,6,-4,10,-6v4,-2,8,-3,12,-3v4,0,8,1,12,3v4,2,7,3,10,6v3,3,4,6,6,10v2,4,3,9,3,13v0,4,-1,8,-3,12v-2,4,-3,7,-6,10v-3,3,-6,4,-10,6v-4,2,-8,3,-12,3v-4,0,-8,-1,-12,-3v-4,-2,-7,-3,-10,-6v-3,-3,-5,-6,-7,-10v-2,-4,-2,-8,-2,-12","w":94},";":{"d":"13,-159v0,-4,0,-9,2,-13v2,-4,4,-7,7,-10v3,-3,6,-4,10,-6v4,-2,8,-3,12,-3v4,0,8,1,12,3v4,2,7,3,10,6v3,3,4,6,6,10v2,4,3,9,3,13v0,4,-1,8,-3,12v-2,4,-3,7,-6,10v-3,3,-6,4,-10,6v-4,2,-8,3,-12,3v-4,0,-8,-1,-12,-3v-4,-2,-7,-3,-10,-6v-3,-3,-5,-6,-7,-10v-2,-4,-2,-8,-2,-12xm22,-50r53,19r-50,95r-36,-14","w":94},"`":{"d":"81,-207r-51,-50r0,-5r57,0r34,55r-40,0","w":136},"^":{"d":"136,-266r71,139r-52,0r-47,-93r-48,93r-51,0r73,-139r54,0","w":216},"\u00a0":{"w":72}}});
        
    }
    
    function initSkillsCloud(){
        if(!$('#skills-cloud').size()) return;
        
        var colorArray = ['#aea268','#4f5205','#d5c884','#677079','#f99c1b','#9b1f3b','#e0d114','#7f1835','#b2b3b7','#aeb213'],
            cnt = 0;
         $('#skills-cloud li').each(function(el,i){
             $(this).css('background-color',colorArray[cnt]);
             cnt = (cnt == 9) ? 0 : ++cnt;
         });
        
        $('#skills-cloud').isotope();
    }

    return {
        // public
        init: init
    };
})();

jQuery(document).ready(skills.common.init);

